#include "expr_ops_make.icc"
// -----------------------------------------------------------------------------
/*
   mixt field and nonlinear functions and operators, as:

	field vh = interpolate (Xh, pow(fabs(uh),p));
	Float err_l1 = integrate(omega, fabs(uh-u()), qopt);
	form m (Xh, Xh, "mass", 1/norm(grad_uh));

   type:			abbrev

   int 				s1
   T				s2	n_scalar=2

   field<T,M>			C1	n_class=5
   field_indirect<T,M>		C2	=> seront tous convertis en field<T,M>
   field_indirect_const<T,M>	C3
   field_component<T,M>		C4
   field_component_const<T,M>	C5

   field_expr<E>		L	linear expr
   Function			F	
   field_nonlinear_expr<E>	N	nonlinear expr

 Note: le caractere value' (field scalar, vector, tensor) peut etre connu
 a la compilation (pour les constantes ou les class-function) mais n'est connu
 qu'a l'execution pour les field.
 => il va falloir va instancier toutes les possibilites
    et essayer d'eviter au maximum les tests a l'execution

*/
// =====================================================================================
// part 1 : unary operations +x -x
// =====================================================================================
void nl_unop_init (const op& o, s details) {
  cout << "namespace " << details << " {" << endl
       << "  struct " << o.tag << " {" << endl
       << "    template <class T> T operator() (const T& a) const { return " << o.name << "a; }" << endl
       << "  };" << endl
       << "} // namepace " << details << endl
       << "template<>" << endl
       << "struct generic_unary_traits<" << details << "::" << o.tag << "> {" << endl
       << "  template<class T>" << endl
       << "  struct with {" << endl
       << "    typedef T       argument_type;" << endl
       << "    typedef T         result_type;" << endl
       << "    typedef " << details << "::" << o.tag << " function_type;" << endl
       << "  };" << endl
       << "  template <class Arg>" << endl
       << "  struct result_hint {" << endl
       << "    typedef Arg type;" << endl
       << "  };" << endl
       << "  static space_constant::valued_type" << endl
       << "  valued_tag (space_constant::valued_type tag) { " << endl
       << "    return tag;" << endl
       << "  }" << endl
       << "};" << endl;
}
void nl_unop_base (const op& o, s details, s arg, s w_arg) {
  cout << "inline" << endl
       << "field_nonlinear_expr<" << endl
       << "  field_nonlinear_expr_uf<" << endl
       << "      detail_nonlinear_expr::" << o.tag << "" << endl
       << "     ," << w_arg << endl
       << "    >" << endl
       << "  >" << endl
       << "operator" << o.name << " (const " << arg << "& x)" << endl
       << "{" << endl
       << "  typedef " << w_arg << " arg_t;" << endl
       << "  typedef field_nonlinear_expr_uf<detail_nonlinear_expr::" << o.tag << ", arg_t>   expr_t;" << endl
       << "  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::" << o.tag << "(), arg_t(x)));" << endl
       << "}" << endl;
}
void nl_unop (const op& o, const vector<s>& Class, s details) {
  nl_unop_init (o, details);
  // Note: op(C) and op(L) are linear, already handled by field_expr<Expr>
  // op(N)
  cout << "template<class Expr>" << endl;
  nl_unop_base (o, details,
	"field_nonlinear_expr<Expr>",
	"field_nonlinear_expr<Expr>");
  // op(F)
  cout << "template<class Function>" << endl;
  nl_unop_base (o, details,
	"field_expr_terminal_function<Function>", 
	"field_expr_terminal_function<Function>"); 
}
// -----------------------------------------------------------------------------
void nl_all_unops (const vector<op>& Op, const vector<s>& Class, s details) {
  for (size_t i = 0; i < Op.size(); i++) {
    nl_unop (Op[i], Class, details);
  }
}
// =====================================================================================
// part 2 : binary operations x+y x-y, x*y, x/y
// =====================================================================================
/*
       +-  s v t
         s s ? ?
         v ? v ?     les args doivent avoir le meme caractere value'
         t ? ? t          
*/
void nl_plusminus_init (const op& o, s details) {
  cout << "namespace " << details << " {" << endl
       << "  struct " << o.tag << " {" << endl
       << "    template <class T> T operator() (const T& a, const T& b) const { return a" << o.name << "b; }" << endl
       << "  };" << endl
       << "} // namepace " << details << "" << endl
       << "template<>" << endl
       << "struct generic_binary_traits<" << details << "::" << o.tag << "> {" << endl
       << "  template<class T>" << endl
       << "  struct with {" << endl
       << "    typedef T       first_argument_type;" << endl
       << "    typedef T      second_argument_type;" << endl
       << "    typedef T               result_type;" << endl
       << "    typedef " << details << "::" << o.tag << " function_type;" << endl
       << "  };" << endl
       << "  template <class Arg1, class Arg2>" << endl
       << "  struct result_hint {" << endl
       << "    typedef typename promote<Arg1,Arg2>::type type;" << endl
       << "  };" << endl
       << "  static space_constant::valued_type" << endl
       << "  valued_tag (space_constant::valued_type tag1, space_constant::valued_type tag2) { " << endl
       << "    return (tag2 == space_constant::last_valued) ? tag1 : tag2;" << endl
       << "  }" << endl
       << "};" << endl;
}
void nl_mul_result (const op& o, s details) {
/*
         * s v t
         s s v t
         v v ? ?              v*v => voir dot(uh,vh) -> scalar ou otimes(uh,vh) -> tensor
         t s v t              v*t => voir trans(uh)*tau_h -> vector
*/
  // ss,vv,tt
  cout << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<T,T> {" << endl
       << "    typedef T type;" << endl
       << "  };" << endl
       << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<point_basic<T>,point_basic<T> > {" << endl
       << "    typedef undeterminated_basic<T> type;" << endl
       << "  };" << endl
       // sv
       << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<point_basic<T>,T> {" << endl
       << "    typedef point_basic<T> type;" << endl
       << "  };" << endl
       << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<T,point_basic<T> > {" << endl
       << "    typedef point_basic<T> type;" << endl
       << "  };" << endl
       // st
       << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<tensor_basic<T>,T> {" << endl
       << "    typedef tensor_basic<T> type;" << endl
       << "  };" << endl
       << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<T,tensor_basic<T> > {" << endl
       << "    typedef tensor_basic<T> type;" << endl
       << "  };" << endl
       // vt
       << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<tensor_basic<T>,point_basic<T> > {" << endl
       << "    typedef point_basic<T> type;" << endl
       << "  };" << endl
       << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<point_basic<T>,tensor_basic<T> > {" << endl
       << "    typedef undeterminated_basic<T> type;" << endl
       << "  };" << endl
       ;
}
void nl_div_result (const op& o, s details) {
/*
         / s v t
         s s ? ?
         v v ? ?              le second arg doit etre scalaire
         t s ? ?          
*/
  cout << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<T,T> {" << endl
       << "    typedef T type;" << endl
       << "  };" << endl
       << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<point_basic<T>,T> {" << endl
       << "    typedef point_basic<T> type;" << endl
       << "  };" << endl
       << "  template <class T> " << endl
       << "  struct " << o.tag << "_result<tensor_basic<T>,T> {" << endl
       << "    typedef tensor_basic<T> type;" << endl
       << "  };" << endl
       ;
}
void nl_muldiv_init (const op& o, s details) {
  cout << "namespace " << details << " {" << endl
       << "  template <class T1, class T2> " << endl
       << "  struct " << o.tag << "_result {" << endl
       << "    typedef undeterminated_basic<typename promote<typename scalar_traits<T1>::type,typename scalar_traits<T2>::type>::type> type;" << endl
       << "  };" << endl;
  if (o.name == "*") nl_mul_result(o, details); else nl_div_result(o, details);
  cout << "  struct " << o.tag << " {" << endl
       << "    template <class T1, class T2>" << endl
       << "    typename " << o.tag << "_result<T1,T2>::type" << endl
       << "    operator() (const T1& a, const T2& b) const { return a" << o.name << "b; }" << endl
       << "  };" << endl
       << "} // namepace " << details << "" << endl
       << "template<>" << endl
       << "struct generic_binary_traits<" << details << "::" << o.tag << "> {" << endl
       << "  template<class Result>" << endl
       << "  struct with {" << endl
       << "    typedef Result  result_type;" << endl
       << "    typedef typename scalar_traits<Result>::type       scalar_type;" << endl
       << "    typedef undeterminated_basic<scalar_type>  first_argument_type;" << endl
       << "    typedef undeterminated_basic<scalar_type> second_argument_type;" << endl
       << "    typedef " << details << "::" << o.tag << " function_type;" << endl
       << "  };" << endl
       << "  template <class Arg1, class Arg2>" << endl
       << "  struct result_hint {" << endl
       << "    typedef typename " << details << "::" << o.tag << "_result<Arg1,Arg2>::type type;" << endl
       << "  };" << endl
       << "  static space_constant::valued_type" << endl
       << "  valued_tag (space_constant::valued_type tag1, space_constant::valued_type tag2) { " << endl
       << "    return space_constant::" << o.tag << "_result_tag(tag1,tag2);" << endl
       << "  }" << endl
       << "};" << endl;
}
void nl_binop_init (const op& o, s details) {
  if (o.name == "+" || o.name == "-")
    nl_plusminus_init (o, details);
  else
    nl_muldiv_init    (o, details);
}
void nl_binop_base (const op& o, s details, s arg1, s w_arg1, s arg2, s w_arg2) {
  s wx = (arg1 == w_arg1) ? "x" : "arg1_t(x)";
  s wy = (arg2 == w_arg2) ? "y" : "arg2_t(y)";
  cout << "inline" << endl
       << "field_nonlinear_expr<" << endl
       << "  field_nonlinear_expr_bf<" << endl
       << "      " << details << "::" << o.tag << endl
       << "     ," << w_arg1 << endl
       << "     ," << w_arg2 << endl
       << "    >" << endl
       << "  >" << endl
       << "operator" << o.name <<" (const " << arg1 << "& x, const " << arg2 << "& y)" << endl
       << "{" << endl
       << "  typedef " << w_arg1 << " arg1_t;" << endl
       << "  typedef " << w_arg2 << " arg2_t;" << endl
       << "  typedef field_nonlinear_expr_bf<" << details << "::" << o.tag << ", arg1_t, arg2_t>   expr_t;" << endl
       << "  return field_nonlinear_expr<expr_t>(expr_t(" << details << "::" << o.tag << "(), " << wx << ", " << wy << "));" << endl
       << "}" << endl;
}
void nl_binop_bind_scalar (const op& o, s details, size_t i, s scalar, s arg, s w_arg) {
  s binder = (i == 1) ? "binder1st" : "binder2nd";
  s arg1 = (i == 1) ? scalar : arg;
  s arg2 = (i == 2) ? scalar : arg;
  s cte  = (i == 1) ? "x" : "y";
  s expr = (i == 2) ? "x" : "y";
  s w_expr = (arg == w_arg) ? expr : "arg_t("+expr+")";
  cout << "inline" << endl
       << "field_nonlinear_expr<" << endl
       << "  field_nonlinear_expr_uf<" << endl
       << "    std::" << binder << "<std::" << o.tag << "<" << scalar << "> >" << endl
       << "   ," << w_arg << endl
       << "  >" << endl
       << ">" << endl
       << "operator" << o.name << " (const " << arg1 << "& x, const " << arg2 << "& y)" << endl
       << "{" << endl
       << "  typedef " << scalar << "                        scalar_t;" << endl
       << "  typedef std::" << binder << "<std::" << o.tag << "<scalar_t> > fun_t;" << endl
       << "  typedef " << w_arg << "                         arg_t;" << endl
       << "  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;" << endl
       << "  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::" << o.tag << "<scalar_t>(), " << cte << "), " << w_expr << "));" << endl
       << "}" << endl;
}
// -----------------------------------------------------------------------------
void nl_binop (const op& o, const vector<s>& Class, s details) {
/*
    + -   s C L F N
	s s L L * *
	C L L L * *
        L L L L * *
	F * * * * *
        N * * * * *

  *       s C L F N
	s s L L * *   une partie est lineaire
	C L * * * *		c*uh, uh*c mais pas uh*vh
        L L * * * *
	F * * * * *
        N * * * * *

  /       s C L F N
	s s * * * *   une partie est lineaire
	C L * * * *		uh/c mais pas c/uh ni uh/vh
        L L * * * *	=> non symmetrique (non communtatif)
	F * * * * *
        N * * * * *

   Probleme: uh*vh peut etre defini avec uh scalaire et vh scalaire, vecteur ou tenseur
*/
  nl_binop_init (o, details);
  bool op_is_nonlinear = (o.name == "*" || o.name == "/");
  // ------------------
  // op(sX), X=C,L,N,F
  // ------------------
  for (size_t i = 1; i <= 2; i++) {
    if (o.name == "/" && i == 1) {
      for (size_t j = 0, nc = Class.size(); j < nc; j++) {
        // op(sC)=s/C as 2/uh
        cout << "template<class T, class M>" << endl;
        nl_binop_bind_scalar (o, details, i, 
	  "typename "+Class[j]+"<T,M>::scalar_type",
	  Class[j]+"<T,M>", 
	  "field_expr_terminal_field<T,M>");
      }
      // op(sL)=s/L as 2/(uh+vh)
      cout << "template<class Expr>" << endl;
      nl_binop_bind_scalar (o, details, i, 
	"typename field_expr<Expr>::scalar_type",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");
    }
    // op(sN), op(Ns)
    cout << "template<class Expr>" << endl;
    nl_binop_bind_scalar (o, details, i, 
	"typename field_nonlinear_expr<Expr>::scalar_type",
	"field_nonlinear_expr<Expr>",
	"field_nonlinear_expr<Expr>");
    
    // op(sF), op(Fs)
    cout << "template<class Function>" << endl;
    nl_binop_bind_scalar (o, details, i, 
	"typename field_expr_terminal_function<Function>::scalar_type",
	"field_expr_terminal_function<Function>", 
	"field_expr_terminal_function<Function>"); 
  }
  // -------------
  // op(CC)
  // -------------
  if (op_is_nonlinear) {
    for (size_t i = 0, nc = Class.size(); i < nc; i++) {
    for (size_t j = 0, nc = Class.size(); j < nc; j++) {
      cout << "template<class T, class M>" << endl;
      nl_binop_base (o, details,
   	Class[i]+"<T,M>", 
	"field_expr_terminal_field<T,M>",
   	Class[j]+"<T,M>", 
	"field_expr_terminal_field<T,M>");
    }}
  }
  // -------------
  // op(CX), X=F,N
  // -------------
  for (size_t i = 0, nc = Class.size(); i < nc; i++) {
    if (op_is_nonlinear) {
      // op(CL)
      cout << "template<class Expr, class T, class M>" << endl;
      nl_binop_base (o, details,
   	Class[i]+"<T,M>", 
	"field_expr_terminal_field<T,M>",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");
      // op(LC)
      cout << "template<class Expr, class T, class M>" << endl;
      nl_binop_base (o, details,
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>",
   	Class[i]+"<T,M>", 
	"field_expr_terminal_field<T,M>");
    }
    // op(CF)
    cout << "template<class Function, class T, class M>" << endl;
    nl_binop_base (o, details,
   	Class[i]+"<T,M>", 
	"field_expr_terminal_field<T,M>",
	"field_expr_terminal_function<Function>", 
	"field_expr_terminal_function<Function>"); 
    // op(FC)
    cout << "template<class Function, class T, class M>" << endl;
    nl_binop_base (o, details,
	"field_expr_terminal_function<Function>", 
        "field_expr_terminal_function<Function>", 
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>");

    // op(NC)
    cout << "template<class Expr, class T, class M>" << endl;
    nl_binop_base (o, details,
	"field_nonlinear_expr<Expr>", 
	"field_nonlinear_expr<Expr>", 
	Class[i]+"<T,M>",
	"field_expr_terminal_field<T,M>");
    // op(CN)
    cout << "template<class Expr, class T, class M>" << endl;
    nl_binop_base (o, details,
	Class[i]+"<T,M>", 
	"field_expr_terminal_field<T,M>",
	"field_nonlinear_expr<Expr>",
	"field_nonlinear_expr<Expr>");
  }
  if (op_is_nonlinear) {
    // op(LL)
    cout << "template<class Expr1, class Expr2>" << endl;
    nl_binop_base (o, details,
        "field_expr<Expr1>",
        "field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>",
        "field_expr<Expr2>",
        "field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>");
  }
  // ----------------------
  // op(XY), X,Y=L,F,N
  // ----------------------
  // op(LF)
  cout << "template<class Expr, class Function>" << endl;
  nl_binop_base (o, details,
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>",
        "field_expr_terminal_function<Function>", 
        "field_expr_terminal_function<Function>");
  // op(FL)
  cout << "template<class Expr, class Function>" << endl;
  nl_binop_base (o, details,
        "field_expr_terminal_function<Function>", 
        "field_expr_terminal_function<Function>",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");

  // op(NF)
  cout << "template<class Expr, class Function>" << endl;
  nl_binop_base (o, details,
	"field_nonlinear_expr<Expr>",
        "field_nonlinear_expr<Expr>", 
        "field_expr_terminal_function<Function>", 
        "field_expr_terminal_function<Function>");
  // op(FN)
  cout << "template<class Expr, class Function>" << endl;
  nl_binop_base (o, details,
	"field_expr_terminal_function<Function>", 
	"field_expr_terminal_function<Function>", 
	"field_nonlinear_expr<Expr>", 
	"field_nonlinear_expr<Expr>");

  // op(LN)
  cout << "template<class Expr1, class Expr2>" << endl;
  nl_binop_base (o, details,
        "field_expr<Expr1>",
        "field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>",
	"field_nonlinear_expr<Expr2>",
	"field_nonlinear_expr<Expr2>");
  // op(NL)
  cout << "template<class Expr1, class Expr2>" << endl;
  nl_binop_base (o, details,
	"field_nonlinear_expr<Expr1>",
	"field_nonlinear_expr<Expr1>",
        "field_expr<Expr2>",
        "field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>");

  // op(FF)
  cout << "template<class Function1, class Function2>" << endl;
  nl_binop_base (o, details,
	"field_expr_terminal_function<Function1>", 
	"field_expr_terminal_function<Function1>", 
	"field_expr_terminal_function<Function2>", 
	"field_expr_terminal_function<Function2>");
 
  // op(NN)
  cout << "template<class Expr1, class Expr2>" << endl;
  nl_binop_base (o, details,
	"field_nonlinear_expr<Expr1>",
	"field_nonlinear_expr<Expr1>", 
	"field_nonlinear_expr<Expr2>",
	"field_nonlinear_expr<Expr2>");
}
// -----------------------------------------------------------------------------
void nl_all_binops (const vector<op>& Op, const vector<s>& Class, s details) {
  for (size_t i = 0; i < Op.size(); i++) {
    nl_binop (Op[i], Class, details);
  }
}
// =====================================================================================
// part 3 : unary fct: sin(uh), etc
// =====================================================================================
void nl_ufunc_init (const func& f, s details) {
  cout << "namespace " << details << " {" << endl
       << "  template<class T>" << endl
       << "  struct " << f.f << "_ : std::unary_function<T,T> {" << endl
       << "    T operator() (const T& x) const { return " << f.f << "(x); }" << endl
       << "  };" << endl
       << "} // namespace " << details << endl;
}
// -----------------------------------------------------------------------------
void nl_ufunc_base (const func& f, s details, s arg, s w_arg) {
  s wx = (arg == w_arg) ? "x" : "arg_t(x)";
  cout << "inline" << endl
       << "field_nonlinear_expr<" << endl
       << "  field_nonlinear_expr_uf<" << endl
       << "    " << details << "::" << f.f << "_<typename " << arg << "::scalar_type>" << endl
       << "   ," << w_arg << endl
       << "  >" << endl
       << ">" << endl
       << "" << f.f << " (const " << arg << "& x) {" << endl
       << "  typedef " << details << "::" << f.f << "_<typename " << arg << "::scalar_type> fun_t;" << endl
       << "  typedef " << w_arg << "                          arg_t;" << endl
       << "  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;" << endl
       << "  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), " << wx << "));" << endl
       << "}" << endl;
}
// -----------------------------------------------------------------------------
void nl_ufunc (const func& f, const vector<s>& Class, s details) {
  nl_ufunc_init (f, details);
  // f(C)
  for (size_t i = 0, nc = Class.size(); i < nc; i++) {
    cout << "template<class T, class M>" << endl;
    nl_ufunc_base (f, details,
                    Class[i]+"<T,M>",
                    "field_expr_terminal_field<T,M>");
  }
  // f(L)
  cout << "template<class Expr>" << endl;
  nl_ufunc_base (f, details,
                    "field_expr<Expr>",
                    "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");
  // f(N)
  cout << "template<class Expr>" << endl;
  nl_ufunc_base (f, details,
                    "field_nonlinear_expr<Expr>",
                    "field_nonlinear_expr<Expr>");
}
// -----------------------------------------------------------------------------
void nl_all_ufunc (const vector<func>& f, const vector<s>& Class, s details) {
  for (size_t i = 0; i < f.size(); i++) {
    nl_ufunc (f[i], Class, details);
  }
}
// =====================================================================================
// part 4 : binary func: pow(x,y), ...
// =====================================================================================
void nl_bifunc_init (const func& f, s details) {
  cout << "namespace " << details << " {" << endl
       << "  template<class T>" << endl
       << "  struct " << f.f << "_ : std::binary_function<T,T,T> {" << endl
       << "    T operator() (const T& x, const T& y) const { return " << f.f << "(x,y); }" << endl
       << "  };" << endl
       << "} // namespace " << details << endl;
}
void nl_bifunc_bind_scalar (const func& f, s details, size_t i, s scalar, s arg, s w_arg) {
  s binder = (i == 1) ? "binder1st" : "binder2nd";
  s arg1 = (i == 1) ? scalar : arg;
  s arg2 = (i == 2) ? scalar : arg;
  s cte  = (i == 1) ? "x" : "y";
  s expr = (i == 2) ? "x" : "y";
  s w_expr = (arg == w_arg) ? expr : "arg_t("+expr+")";
  cout << "inline" << endl
       << "field_nonlinear_expr<" << endl
       << "  field_nonlinear_expr_uf<" << endl
       << "    std::" << binder << "<" << details << "::" << f.f << "_<typename promote<" << scalar << ",typename " << arg << "::scalar_type>::type> >" << endl
       << "   ," << w_arg << endl
       << "  >" << endl
       << ">" << endl
       << "" << f.f << " (const " << arg1 << "& x, const " << arg2 << "& y) {" << endl
       << "  typedef " << w_arg << "                                      arg_t;" << endl
       << "  typedef typename promote<" << scalar << ",typename arg_t::scalar_type>::type scalar_t;" << endl
       << "  typedef " << details << "::" << f.f << "_<scalar_t>           funb_t;" << endl
       << "  typedef std::" << binder << "<funb_t>                        fun_t;" << endl
       << "  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;" << endl
       << "  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), " << cte << "), " << w_expr << "));" << endl
       << "}" << endl;
}
void nl_bifunc_base (const func& f, s details, s arg1, s w_arg1, s arg2, s w_arg2) {
  s wx = (arg1 == w_arg1) ? "x" : "arg1_t(x)";
  s wy = (arg2 == w_arg2) ? "y" : "arg2_t(y)";
  cout << "inline" << endl
       << "field_nonlinear_expr<" << endl
       << "  field_nonlinear_expr_bf<" << endl
       << "    " << details << "::" << f.f << "_<typename promote<typename " << arg1 << "::scalar_type, typename " << arg2 << "::scalar_type>::type>" << endl
       << "   ," << w_arg1 << endl
       << "   ," << w_arg2 << endl
       << "  >" << endl
       << ">" << endl
       << "" << f.f << " (const " << arg1 << "& x, const " << arg2 << "& y) {" << endl
       << "  typedef " << w_arg1 << "                                     arg1_t;" << endl
       << "  typedef " << w_arg2 << "                                     arg2_t;" << endl
       << "  typedef typename promote<typename " << arg1 << "::scalar_type, typename " << arg2 << "::scalar_type>::type scalar_t;" << endl
       << "  typedef " << details << "::" << f.f << "_<scalar_t>           fun_t;" << endl
       << "  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;" << endl
       << "  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), " << wx << ", " << wy << "));" << endl
       << "}" << endl;
}
void nl_bifunc (const func& f, const vector<s>& Class, s details) {
/*  fun   s C L F N
	s s * * * *
	C * * * * *
        L * * * * *
	F * * * * *
        N * * * * *
*/
  nl_bifunc_init        (f, details);
  // ---------------------------
  // f(iX), f(Xi); f(sX), f(Xs)
  // ---------------------------
  for (size_t i = 1; i <= 2; i++) {

    for (size_t j = 0, nc = Class.size(); j < nc; j++) {
      // f(iC), f(Ci)
      cout << "template<class T, class M>" << endl;
      nl_bifunc_bind_scalar (f, details, i,
	"int",
        Class[j]+"<T,M>",
        "field_expr_terminal_field<T,M>");

      // f(sC), f(Cs)
      cout << "template<class T, class M>" << endl;
      nl_bifunc_bind_scalar (f, details, i,
	"typename "+Class[j]+"<T,M>::scalar_type",
        Class[j]+"<T,M>",
        "field_expr_terminal_field<T,M>");
    }
    // f(iF), f(Fi)
    cout << "template<class Function1>" << endl;
    nl_bifunc_bind_scalar (f, details, i,
	"int",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");
    // f(sF), f(Fs)
    cout << "template<class Function1>" << endl;
    nl_bifunc_bind_scalar (f, details, i,
        "typename field_expr_terminal_function<Function1>::scalar_type",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");

    // f(iL), f(Li)
    cout << "template<class Expr>" << endl;
    nl_bifunc_bind_scalar (f, details, i,
	"int",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");
    // f(sL), f(Ls)
    cout << "template<class Expr>" << endl;
    nl_bifunc_bind_scalar (f, details, i,
        "typename field_expr<Expr>::scalar_type",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");

    // f(iN), f(Ni)
    cout << "template<class Expr>" << endl;
    nl_bifunc_bind_scalar (f, details, i,
	"int",
	"field_nonlinear_expr<Expr>",
	"field_nonlinear_expr<Expr>");
    // f(sN), f(Ns)
    cout << "template<class Expr>" << endl;
    nl_bifunc_bind_scalar (f, details, i,
	"typename field_nonlinear_expr<Expr>::scalar_type",
	"field_nonlinear_expr<Expr>",
	"field_nonlinear_expr<Expr>");
  }
  // ---------------------------
  // f(CC)
  // ---------------------------
  for (size_t i = 0, nc = Class.size(); i < nc; i++) {
  for (size_t j = 0, nc = Class.size(); j < nc; j++) {
    cout << "template<class T, class M>" << endl;
    nl_bifunc_base (f, details,
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>",
        Class[j]+"<T,M>",
        "field_expr_terminal_field<T,M>");
  }}
  // ---------------------------
  // f(CX), X=L,F,N
  // ---------------------------
  for (size_t i = 0, nc = Class.size(); i < nc; i++) {
    // f(CL)
    cout << "template<class T, class M, class Expr>" << endl;
    nl_bifunc_base (f, details,
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");
    // f(LC)
    cout << "template<class T, class M, class Expr>" << endl;
    nl_bifunc_base (f, details,
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>",
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>");

    // f(CF)
    cout << "template<class T, class M, class Function1>" << endl;
    nl_bifunc_base (f, details,
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");
    // f(FC)
    cout << "template<class T, class M, class Function1>" << endl;
    nl_bifunc_base (f, details,
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>",
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>");

    // f(CN)
    cout << "template<class T, class M, class Expr>" << endl;
    nl_bifunc_base (f, details,
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>",
	"field_nonlinear_expr<Expr>",
	"field_nonlinear_expr<Expr>");
    // f(NC)
    cout << "template<class T, class M, class Expr>" << endl;
    nl_bifunc_base (f, details,
        "field_nonlinear_expr<Expr>",
        "field_nonlinear_expr<Expr>",
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>");
  }
  // ---------------------------
  // f(XY), X,Y=L,F,N
  // ---------------------------
  // f(LL)
  cout << "template<class Expr1, class Expr2>" << endl;
  nl_bifunc_base (f, details,
        "field_expr<Expr1>",
        "field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>",
        "field_expr<Expr2>",
        "field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>");

  // f(LN)
  cout << "template<class Expr1, class Expr2>" << endl;
  nl_bifunc_base (f, details,
        "field_expr<Expr1>",
        "field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>",
        "field_nonlinear_expr<Expr2>",
        "field_nonlinear_expr<Expr2>");

  // f(NL)
  cout << "template<class Expr1, class Expr2>" << endl;
  nl_bifunc_base (f, details,
        "field_nonlinear_expr<Expr1>",
        "field_nonlinear_expr<Expr1>",
        "field_expr<Expr2>",
        "field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>");

  // f(NN)
  cout << "template<class Expr1, class Expr2>" << endl;
  nl_bifunc_base (f, details,
        "field_nonlinear_expr<Expr1>",
        "field_nonlinear_expr<Expr1>",
        "field_nonlinear_expr<Expr2>",
        "field_nonlinear_expr<Expr2>");

  // f(LF)
  cout << "template<class Expr, class Function1>" << endl;
  nl_bifunc_base (f, details,
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");

  // f(FL)
  cout << "template<class Expr, class Function1>" << endl;
  nl_bifunc_base (f, details,
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");


  // f(NF)
  cout << "template<class Expr, class Function1>" << endl;
  nl_bifunc_base (f, details,
        "field_nonlinear_expr<Expr>",
        "field_nonlinear_expr<Expr>",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");

  // f(FN)
  cout << "template<class Expr, class Function1>" << endl;
  nl_bifunc_base (f, details,
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>",
        "field_nonlinear_expr<Expr>",
        "field_nonlinear_expr<Expr>");

  // f(FF)
  cout << "template<class Function1, class Function2>" << endl;
  nl_bifunc_base (f, details,
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function2>",
        "field_expr_terminal_function<Function2>");
}
void nl_all_bifunc (const vector<func>& f, const vector<s>& Class, s details) {
  for (size_t i = 0; i < f.size(); i++) {
    nl_bifunc (f[i], Class, details);
  }
}
// =====================================================================================
// part 5 : norm & norm2 (specific unary)
// =====================================================================================
void nl_norm_init (s name, s details) {
  s sname = (name == "norm") ? "fabs" : "sqr"; // scalar case alternative (norm, norm2)
  cout << "namespace " << details << " {" << endl
       << "struct " << name << "_ {" << endl
       << "  template<class T>" << endl
       << "  typename float_traits<T>::type operator() (const T& x) const { return " << sname << "(x); }" << endl
       << "  template<class T>" << endl
       << "  typename float_traits<T>::type operator() (const point_basic<T>& x) const { return " << name << "(x); }" << endl
       << "  template<class T>" << endl
       << "  typename float_traits<T>::type operator() (const tensor_basic<T>& x) const { return " << name << "(x); }" << endl
       << "};" << endl
       << "} // namespace " << details << endl
       << "template<>" << endl
       << "struct generic_unary_traits<" << details << "::" << name << "_> {" << endl
       << "  template<class ResultType>" << endl
       << "  struct with {" << endl
       << "    typedef undeterminated_basic<ResultType>  argument_type;" << endl
       << "    typedef ResultType                        result_type;" << endl
       << "    typedef " << details << "::" << name << "_           function_type;" << endl
       << "  };" << endl
       << "  template <class Arg>" << endl
       << "  struct result_hint {" << endl
       << "    typedef typename float_traits<Arg>::type  type;" << endl
       << "  };" << endl
       << "  static space_constant::valued_type" << endl
       << "  valued_tag (space_constant::valued_type tag) {" << endl
       << "    return space_constant::scalar;" << endl
       << "  }" << endl
       << "};" << endl
       ;
}
void nl_norm_base (s name, s details, s arg, s w_arg) {
  s wx = (arg == w_arg) ? "x" : "arg_t(x)";
  cout << "inline" << endl
       << "field_nonlinear_expr<" << endl
       << "  field_nonlinear_expr_uf<" << endl
       << "    " << details << "::" << name << "_" << endl
       << "   ," << w_arg << endl
       << "  >" << endl
       << ">" << endl
       << "" << name << " (const " << arg << "& x) {" << endl
       << "  typedef " << details << "::" << name << "_      fun_t;" << endl
       << "  typedef " << w_arg << "                         arg_t;" << endl
       << "  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;" << endl
       << "  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), " << wx << "));" << endl
       << "}" << endl
       ;
}
void nl_norm (s name, const vector<s>& Class, s details) {
  nl_norm_init (name, details);
  // norm(C)
  for (size_t i = 0, nc = Class.size(); i < nc; i++) {
    cout << "template<class T, class M>" << endl;
    nl_norm_base (name, details,
  	Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>");
  }
  // norm(L)
  cout << "template<class Expr>" << endl;
  nl_norm_base (name, details,
       	"field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");
  // norm(F)
  cout << "template<class Function>" << endl;
  nl_norm_base (name, details,
        "field_expr_terminal_function<Function>",
        "field_expr_terminal_function<Function>");
  // norm(N)
  cout << "template<class Expr>" << endl;
  nl_norm_base (name, details,
       	"field_nonlinear_expr<Expr>",
       	"field_nonlinear_expr<Expr>");
}
// =====================================================================================
// part 6 : compose (f,expr) <==> f(expr)
// =====================================================================================
void nl_compose1_base (s details, s arg, s w_arg) {
  s wx = (arg == w_arg) ? "x" : "arg_t(x)";
  cout << "inline" << endl
       << "field_nonlinear_expr<" << endl
       << "  field_nonlinear_expr_uf<" << endl
       << "    Function" << endl
       << "   ," << w_arg << endl
       << "  >" << endl
       << ">" << endl
       << "compose (const Function& f, const " << arg << "& x) {" << endl
       << "  typedef " << w_arg << "                          arg_t;" << endl
       << "  typedef field_nonlinear_expr_uf<Function, arg_t> expr_t;" << endl
       << "  return field_nonlinear_expr<expr_t> (expr_t(f, " << wx << "));" << endl
       << "}" << endl
       ;
}
void nl_compose1 (const vector<s>& Class, s details) {
  for (size_t i = 0, nc = Class.size(); i < nc; i++) {
    // f(C)
    cout << "template<class T, class M, class Function>" << endl;
    nl_compose1_base (details,
       Class[i]+"<T,M>",
       "field_expr_terminal_field<T,M>");
  }
  // f(L)
  cout << "template<class Expr, class Function>" << endl;
  nl_compose1_base (details,
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");

  // f(N)
  cout << "template<class Expr, class Function>" << endl;
  nl_compose1_base (details,
       "field_nonlinear_expr<Expr>",
       "field_nonlinear_expr<Expr>");

  // f(F)
  cout << "template<class Function1, class Function>" << endl;
  nl_compose1_base (details,
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");
}
// =====================================================================================
// part 7 : compose (f,expr1,expr2) <==> f(expr1,expr2)
// =====================================================================================
void nl_compose2_base (s details, s arg1, s w_arg1, s arg2, s w_arg2) {
  s wx = (arg1 == w_arg1) ? "x" : "arg1_t(x)";
  s wy = (arg2 == w_arg2) ? "y" : "arg2_t(y)";
  cout << "inline" << endl
       << "field_nonlinear_expr<" << endl
       << "  field_nonlinear_expr_bf<" << endl
       << "    Function," << endl
       << "    " << w_arg1 << endl
       << "   ," << w_arg2 << endl
       << "  >" << endl
       << ">" << endl
       << "compose (const Function& f, const " << arg1 << "& x, const " << arg2 << "& y) {" << endl
       << "  typedef " << w_arg1 << " arg1_t;" << endl
       << "  typedef " << w_arg2 << " arg2_t;" << endl
       << "  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;" << endl
       << "  return field_nonlinear_expr<expr_t>(expr_t(f, " << wx << ", " << wy << "));" << endl
       << "}" << endl;
}
void nl_compose_bind_scalar (s details, size_t i, s scalar, s arg, s w_arg) {
  s binder = (i == 1) ? "binder1st" : "binder2nd";
  s arg1 = (i == 1) ? scalar : arg;
  s arg2 = (i == 2) ? scalar : arg;
  s cte  = (i == 1) ? "x" : "y";
  s expr = (i == 2) ? "x" : "y";
  s w_expr = (arg == w_arg) ? expr : "arg_t("+expr+")";
  cout << "inline" << endl
       << "field_nonlinear_expr<" << endl
       << "  field_nonlinear_expr_uf<" << endl
       << "    std::" << binder << "<Function>" << endl
       << "   ," << w_arg << endl
       << "  >" << endl
       << ">" << endl
       << "compose (const Function& f, const " << arg1 << "& x, const " << arg2 << "& y) {" << endl
       << "  typedef " << w_arg << "                                      arg_t;" << endl
       << "  typedef typename promote<" << scalar << ",typename arg_t::scalar_type>::type scalar_t;" << endl
       << "  typedef Function                                             funb_t;" << endl
       << "  typedef std::" << binder << "<funb_t>                        fun_t;" << endl
       << "  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;" << endl
       << "  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), " << cte << "), " << w_expr << "));" << endl
       << "}" << endl;
}
void nl_compose2 (const vector<s>& Class, s details) {
/*  fun   s C L F N
	s s * * * *
	C * * * * *
        L * * * * *
	F * * * * *
        N * * * * *
*/
  // -------------------
  // f(sX), X=C,F,L,N
  // -------------------
  for (size_t i = 1; i <= 2; i++) {
    for (size_t j = 0, nc = Class.size(); j < nc; j++) {
      // f(iC), f(Ci)
      cout << "template<class Function, class T, class M>" << endl;
      nl_compose_bind_scalar (details, i,
	"int",
        Class[j]+"<T,M>",
        "field_expr_terminal_field<T,M>");
      // f(sC), f(Cs)
      cout << "template<class Function, class T, class M>" << endl;
      nl_compose_bind_scalar (details, i,
	"typename "+Class[j]+"<T,M>::scalar_type",
        Class[j]+"<T,M>",
        "field_expr_terminal_field<T,M>");
    }
    // f(iF), f(Fi)
    cout << "template<class Function, class Function1>" << endl;
    nl_compose_bind_scalar (details, i,
	"int",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");
    // f(sF), f(Fs)
    cout << "template<class Function, class Function1>" << endl;
    nl_compose_bind_scalar (details, i,
        "typename field_expr_terminal_function<Function1>::scalar_type",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");

    // f(iL), f(Li)
    cout << "template<class Function, class Expr>" << endl;
    nl_compose_bind_scalar (details, i,
	"int",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");
    // f(sL), f(Ls)
    cout << "template<class Function, class Expr>" << endl;
    nl_compose_bind_scalar (details, i,
        "typename field_expr<Expr>::scalar_type",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");

    // f(iN), f(Ni)
    cout << "template<class Function, class Expr>" << endl;
    nl_compose_bind_scalar (details, i,
	"int",
        "field_nonlinear_expr<Expr>",
        "field_nonlinear_expr<Expr>");
    // f(sN), f(Ns)
    cout << "template<class Function, class Expr>" << endl;
    nl_compose_bind_scalar (details, i,
        "typename field_nonlinear_expr<Expr>::scalar_type",
        "field_nonlinear_expr<Expr>",
        "field_nonlinear_expr<Expr>");
  }
  // -------------------
  // f(CC)
  // -------------------
  for (size_t i = 0, nc = Class.size(); i < nc; i++) {
  for (size_t j = 0, nc = Class.size(); j < nc; j++) {
    // f(CC)
    cout << "template<class Function, class T, class M>" << endl;
    nl_compose2_base (details,
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>",
        Class[j]+"<T,M>",
        "field_expr_terminal_field<T,M>");
  }}
  // ---------------------------
  // f(CX), X=L,F,N
  // ---------------------------
  for (size_t i = 0, nc = Class.size(); i < nc; i++) {
    // f(CF)
    cout << "template<class Function, class Function1, class T, class M>" << endl;
    nl_compose2_base (details,
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");
    // f(FC)
    cout << "template<class Function, class Function1, class T, class M>" << endl;
    nl_compose2_base (details,
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>",
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>");

    // f(CL)
    cout << "template<class Function, class Expr, class T, class M>" << endl;
    nl_compose2_base (details,
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");
    // f(LC)
    cout << "template<class Function, class Expr, class T, class M>" << endl;
    nl_compose2_base (details,
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>",
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>");

    // f(CN)
    cout << "template<class Function, class Expr, class T, class M>" << endl;
    nl_compose2_base (details,
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>",
        "field_nonlinear_expr<Expr>",
        "field_nonlinear_expr<Expr>");
    // f(NC)
    cout << "template<class Function, class Expr, class T, class M>" << endl;
    nl_compose2_base (details,
        "field_nonlinear_expr<Expr>",
        "field_nonlinear_expr<Expr>",
        Class[i]+"<T,M>",
        "field_expr_terminal_field<T,M>");
  }
  // ---------------------------
  // f(XY), X,Y=L,F,N
  // ---------------------------
  // f(LL)
  cout << "template<class Function, class Expr1, class Expr2>" << endl;
  nl_compose2_base (details,
        "field_expr<Expr1>",
        "field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>",
        "field_expr<Expr2>",
        "field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>");

  // f(NN)
  cout << "template<class Function, class Expr1, class Expr2>" << endl;
  nl_compose2_base (details,
        "field_nonlinear_expr<Expr1>",
        "field_nonlinear_expr<Expr1>",
        "field_nonlinear_expr<Expr2>",
        "field_nonlinear_expr<Expr2>");

  // f(LN)
  cout << "template<class Function, class Expr1, class Expr2>" << endl;
  nl_compose2_base (details,
        "field_expr<Expr1>",
        "field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>",
        "field_nonlinear_expr<Expr2>",
        "field_nonlinear_expr<Expr2>");
  // f(NL)
  cout << "template<class Function, class Expr1, class Expr2>" << endl;
  nl_compose2_base (details,
        "field_nonlinear_expr<Expr1>",
        "field_nonlinear_expr<Expr1>",
        "field_expr<Expr2>",
        "field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>");

  // f(FF)
  cout << "template<class Function, class Function1, class Function2>" << endl;
  nl_compose2_base (details,
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function2>",
        "field_expr_terminal_function<Function2>");

  // f(FL)
  cout << "template<class Function, class Function1, class Expr>" << endl;
  nl_compose2_base (details,
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>",
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>");
  // f(LF)
  cout << "template<class Function, class Function1, class Expr>" << endl;
  nl_compose2_base (details,
        "field_expr<Expr>",
        "field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");

  // f(FN)
  cout << "template<class Function, class Function1, class Expr>" << endl;
  nl_compose2_base (details,
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>",
        "field_nonlinear_expr<Expr>",
        "field_nonlinear_expr<Expr>");
  // f(NF)
  cout << "template<class Function, class Function1, class Expr>" << endl;
  nl_compose2_base (details,
        "field_nonlinear_expr<Expr>",
        "field_nonlinear_expr<Expr>",
        "field_expr_terminal_function<Function1>",
        "field_expr_terminal_function<Function1>");
}
// =====================================================================================
int main() {
// =====================================================================================
  s details = "detail_nonlinear_expr";
  header("FIELD_NONLINEAR", "field_nonlinear");

  vector<s> Class;
  Class.push_back ("field_basic");
  Class.push_back ("field_indirect");
  Class.push_back ("field_indirect_const");
  Class.push_back ("field_component");
  Class.push_back ("field_component_const");

  vector<op> Unop;
  Unop.push_back (op("+", "unary_plus"));
  Unop.push_back (op("-", "negate"));
  nl_all_unops (Unop, Class, details);

  vector<op> BinopLinear;
  BinopLinear.push_back (op("+", "plus"));
  BinopLinear.push_back (op("-", "minus"));
  nl_all_binops (BinopLinear, Class, details);

  vector<op> BinopNonlinear;
  BinopNonlinear.push_back (op("*", "multiplies"));
  BinopNonlinear.push_back (op("/", "divides"));
  nl_all_binops (BinopNonlinear, Class, details);

  vector<func> Ufunc;
  Ufunc.push_back (func("cos"));	// std::cmath
  Ufunc.push_back (func("sin"));
  Ufunc.push_back (func("tan"));
  Ufunc.push_back (func("acos"));
  Ufunc.push_back (func("asin"));
  Ufunc.push_back (func("atan"));
  Ufunc.push_back (func("cosh"));
  Ufunc.push_back (func("sinh"));
  Ufunc.push_back (func("tanh"));
  Ufunc.push_back (func("exp"));
  Ufunc.push_back (func("log"));
  Ufunc.push_back (func("log10"));
  Ufunc.push_back (func("sqrt"));
  Ufunc.push_back (func("abs"));
  Ufunc.push_back (func("fabs"));
  Ufunc.push_back (func("floor"));
  Ufunc.push_back (func("ceil"));
  Ufunc.push_back (func("sqr"));	// rheolef extension
  nl_all_ufunc  (Ufunc, Class, details);

  nl_norm ("norm",  Class, details);
  nl_norm ("norm2", Class, details);

  vector<func> Bifunc;
  Bifunc.push_back (func("atan2"));	// std::cmath
  Bifunc.push_back (func("pow"));
  Bifunc.push_back (func("fmod"));
  Bifunc.push_back (func("min"));	// std::algorithm
  Bifunc.push_back (func("max"));
  nl_all_bifunc  (Bifunc, Class, details);

  nl_compose1 (Class, details);
  nl_compose2 (Class, details);

  footer("FIELD_NONLINEAR", "field_nonlinear");
}
