#ifndef _RHEOLEF_FIELD_NONLINEAR_EXPR_OPS_H
#define _RHEOLEF_FIELD_NONLINEAR_EXPR_OPS_H
// do not edit !
// this file has been automatically generated by the command:
// 
//	  ./field_nonlinear_expr_ops_make > field_nonlinear_expr_ops.h
// 
// ==========================================================================
//
// This file is part of Rheolef.
//
// Copyright (C) 2000-2009 Pierre Saramito 
//
// Rheolef is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Rheolef is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Rheolef; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
// ==========================================================================
// 
// field_nonlinear: template expressions
//
// author: Pierre.Saramito@imag.fr
//
// date: 20 march 2011
//
#include "rheolef/promote.h"
#include "rheolef/field_nonlinear_expr.h"
namespace rheolef {
namespace detail_nonlinear_expr {
  struct unary_plus {
    template <class T> T operator() (const T& a) const { return +a; }
  };
} // namepace detail_nonlinear_expr
template<>
struct generic_unary_traits<detail_nonlinear_expr::unary_plus> {
  template<class T>
  struct with {
    typedef T       argument_type;
    typedef T         result_type;
    typedef detail_nonlinear_expr::unary_plus function_type;
  };
  template <class Arg>
  struct result_hint {
    typedef Arg type;
  };
  static space_constant::valued_type
  valued_tag (space_constant::valued_type tag) { 
    return tag;
  }
};
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
      detail_nonlinear_expr::unary_plus
     ,field_nonlinear_expr<Expr>
    >
  >
operator+ (const field_nonlinear_expr<Expr>& x)
{
  typedef field_nonlinear_expr<Expr> arg_t;
  typedef field_nonlinear_expr_uf<detail_nonlinear_expr::unary_plus, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::unary_plus(), arg_t(x)));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
      detail_nonlinear_expr::unary_plus
     ,field_expr_terminal_function<Function>
    >
  >
operator+ (const field_expr_terminal_function<Function>& x)
{
  typedef field_expr_terminal_function<Function> arg_t;
  typedef field_nonlinear_expr_uf<detail_nonlinear_expr::unary_plus, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::unary_plus(), arg_t(x)));
}
namespace detail_nonlinear_expr {
  struct negate {
    template <class T> T operator() (const T& a) const { return -a; }
  };
} // namepace detail_nonlinear_expr
template<>
struct generic_unary_traits<detail_nonlinear_expr::negate> {
  template<class T>
  struct with {
    typedef T       argument_type;
    typedef T         result_type;
    typedef detail_nonlinear_expr::negate function_type;
  };
  template <class Arg>
  struct result_hint {
    typedef Arg type;
  };
  static space_constant::valued_type
  valued_tag (space_constant::valued_type tag) { 
    return tag;
  }
};
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
      detail_nonlinear_expr::negate
     ,field_nonlinear_expr<Expr>
    >
  >
operator- (const field_nonlinear_expr<Expr>& x)
{
  typedef field_nonlinear_expr<Expr> arg_t;
  typedef field_nonlinear_expr_uf<detail_nonlinear_expr::negate, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::negate(), arg_t(x)));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
      detail_nonlinear_expr::negate
     ,field_expr_terminal_function<Function>
    >
  >
operator- (const field_expr_terminal_function<Function>& x)
{
  typedef field_expr_terminal_function<Function> arg_t;
  typedef field_nonlinear_expr_uf<detail_nonlinear_expr::negate, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::negate(), arg_t(x)));
}
namespace detail_nonlinear_expr {
  struct plus {
    template <class T> T operator() (const T& a, const T& b) const { return a+b; }
  };
} // namepace detail_nonlinear_expr
template<>
struct generic_binary_traits<detail_nonlinear_expr::plus> {
  template<class T>
  struct with {
    typedef T       first_argument_type;
    typedef T      second_argument_type;
    typedef T               result_type;
    typedef detail_nonlinear_expr::plus function_type;
  };
  template <class Arg1, class Arg2>
  struct result_hint {
    typedef typename promote<Arg1,Arg2>::type type;
  };
  static space_constant::valued_type
  valued_tag (space_constant::valued_type tag1, space_constant::valued_type tag2) { 
    return (tag2 == space_constant::last_valued) ? tag1 : tag2;
  }
};
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::plus<typename field_nonlinear_expr<Expr>::scalar_type> >
   ,field_nonlinear_expr<Expr>
  >
>
operator+ (const typename field_nonlinear_expr<Expr>::scalar_type& x, const field_nonlinear_expr<Expr>& y)
{
  typedef typename field_nonlinear_expr<Expr>::scalar_type                        scalar_t;
  typedef std::binder1st<std::plus<scalar_t> > fun_t;
  typedef field_nonlinear_expr<Expr>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::plus<scalar_t>(), x), y));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::plus<typename field_expr_terminal_function<Function>::scalar_type> >
   ,field_expr_terminal_function<Function>
  >
>
operator+ (const typename field_expr_terminal_function<Function>::scalar_type& x, const field_expr_terminal_function<Function>& y)
{
  typedef typename field_expr_terminal_function<Function>::scalar_type                        scalar_t;
  typedef std::binder1st<std::plus<scalar_t> > fun_t;
  typedef field_expr_terminal_function<Function>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::plus<scalar_t>(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<std::plus<typename field_nonlinear_expr<Expr>::scalar_type> >
   ,field_nonlinear_expr<Expr>
  >
>
operator+ (const field_nonlinear_expr<Expr>& x, const typename field_nonlinear_expr<Expr>::scalar_type& y)
{
  typedef typename field_nonlinear_expr<Expr>::scalar_type                        scalar_t;
  typedef std::binder2nd<std::plus<scalar_t> > fun_t;
  typedef field_nonlinear_expr<Expr>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::plus<scalar_t>(), y), x));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<std::plus<typename field_expr_terminal_function<Function>::scalar_type> >
   ,field_expr_terminal_function<Function>
  >
>
operator+ (const field_expr_terminal_function<Function>& x, const typename field_expr_terminal_function<Function>::scalar_type& y)
{
  typedef typename field_expr_terminal_function<Function>::scalar_type                        scalar_t;
  typedef std::binder2nd<std::plus<scalar_t> > fun_t;
  typedef field_expr_terminal_function<Function>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::plus<scalar_t>(), y), x));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator+ (const field_basic<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator+ (const field_expr_terminal_function<Function>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator+ (const field_nonlinear_expr<Expr>& x, const field_basic<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator+ (const field_basic<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator+ (const field_indirect<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator+ (const field_expr_terminal_function<Function>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator+ (const field_nonlinear_expr<Expr>& x, const field_indirect<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator+ (const field_indirect<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator+ (const field_indirect_const<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator+ (const field_expr_terminal_function<Function>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator+ (const field_nonlinear_expr<Expr>& x, const field_indirect_const<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator+ (const field_indirect_const<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator+ (const field_component<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator+ (const field_expr_terminal_function<Function>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator+ (const field_nonlinear_expr<Expr>& x, const field_component<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator+ (const field_component<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator+ (const field_component_const<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator+ (const field_expr_terminal_function<Function>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator+ (const field_nonlinear_expr<Expr>& x, const field_component_const<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator+ (const field_component_const<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_function<Function>
    >
  >
operator+ (const field_expr<Expr>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator+ (const field_expr_terminal_function<Function>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_function<Function>
    >
  >
operator+ (const field_nonlinear_expr<Expr>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, y));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_function<Function>
     ,field_nonlinear_expr<Expr>
    >
  >
operator+ (const field_expr_terminal_function<Function>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
     ,field_nonlinear_expr<Expr2>
    >
  >
operator+ (const field_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type> arg1_t;
  typedef field_nonlinear_expr<Expr2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_nonlinear_expr<Expr1>
     ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
    >
  >
operator+ (const field_nonlinear_expr<Expr1>& x, const field_expr<Expr2>& y)
{
  typedef field_nonlinear_expr<Expr1> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, arg2_t(y)));
}
template<class Function1, class Function2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_expr_terminal_function<Function1>
     ,field_expr_terminal_function<Function2>
    >
  >
operator+ (const field_expr_terminal_function<Function1>& x, const field_expr_terminal_function<Function2>& y)
{
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_function<Function2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::plus
     ,field_nonlinear_expr<Expr1>
     ,field_nonlinear_expr<Expr2>
    >
  >
operator+ (const field_nonlinear_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y)
{
  typedef field_nonlinear_expr<Expr1> arg1_t;
  typedef field_nonlinear_expr<Expr2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::plus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::plus(), x, y));
}
namespace detail_nonlinear_expr {
  struct minus {
    template <class T> T operator() (const T& a, const T& b) const { return a-b; }
  };
} // namepace detail_nonlinear_expr
template<>
struct generic_binary_traits<detail_nonlinear_expr::minus> {
  template<class T>
  struct with {
    typedef T       first_argument_type;
    typedef T      second_argument_type;
    typedef T               result_type;
    typedef detail_nonlinear_expr::minus function_type;
  };
  template <class Arg1, class Arg2>
  struct result_hint {
    typedef typename promote<Arg1,Arg2>::type type;
  };
  static space_constant::valued_type
  valued_tag (space_constant::valued_type tag1, space_constant::valued_type tag2) { 
    return (tag2 == space_constant::last_valued) ? tag1 : tag2;
  }
};
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::minus<typename field_nonlinear_expr<Expr>::scalar_type> >
   ,field_nonlinear_expr<Expr>
  >
>
operator- (const typename field_nonlinear_expr<Expr>::scalar_type& x, const field_nonlinear_expr<Expr>& y)
{
  typedef typename field_nonlinear_expr<Expr>::scalar_type                        scalar_t;
  typedef std::binder1st<std::minus<scalar_t> > fun_t;
  typedef field_nonlinear_expr<Expr>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::minus<scalar_t>(), x), y));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::minus<typename field_expr_terminal_function<Function>::scalar_type> >
   ,field_expr_terminal_function<Function>
  >
>
operator- (const typename field_expr_terminal_function<Function>::scalar_type& x, const field_expr_terminal_function<Function>& y)
{
  typedef typename field_expr_terminal_function<Function>::scalar_type                        scalar_t;
  typedef std::binder1st<std::minus<scalar_t> > fun_t;
  typedef field_expr_terminal_function<Function>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::minus<scalar_t>(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<std::minus<typename field_nonlinear_expr<Expr>::scalar_type> >
   ,field_nonlinear_expr<Expr>
  >
>
operator- (const field_nonlinear_expr<Expr>& x, const typename field_nonlinear_expr<Expr>::scalar_type& y)
{
  typedef typename field_nonlinear_expr<Expr>::scalar_type                        scalar_t;
  typedef std::binder2nd<std::minus<scalar_t> > fun_t;
  typedef field_nonlinear_expr<Expr>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::minus<scalar_t>(), y), x));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<std::minus<typename field_expr_terminal_function<Function>::scalar_type> >
   ,field_expr_terminal_function<Function>
  >
>
operator- (const field_expr_terminal_function<Function>& x, const typename field_expr_terminal_function<Function>::scalar_type& y)
{
  typedef typename field_expr_terminal_function<Function>::scalar_type                        scalar_t;
  typedef std::binder2nd<std::minus<scalar_t> > fun_t;
  typedef field_expr_terminal_function<Function>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::minus<scalar_t>(), y), x));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator- (const field_basic<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator- (const field_expr_terminal_function<Function>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator- (const field_nonlinear_expr<Expr>& x, const field_basic<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator- (const field_basic<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator- (const field_indirect<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator- (const field_expr_terminal_function<Function>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator- (const field_nonlinear_expr<Expr>& x, const field_indirect<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator- (const field_indirect<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator- (const field_indirect_const<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator- (const field_expr_terminal_function<Function>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator- (const field_nonlinear_expr<Expr>& x, const field_indirect_const<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator- (const field_indirect_const<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator- (const field_component<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator- (const field_expr_terminal_function<Function>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator- (const field_nonlinear_expr<Expr>& x, const field_component<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator- (const field_component<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator- (const field_component_const<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator- (const field_expr_terminal_function<Function>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator- (const field_nonlinear_expr<Expr>& x, const field_component_const<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator- (const field_component_const<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_function<Function>
    >
  >
operator- (const field_expr<Expr>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator- (const field_expr_terminal_function<Function>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_function<Function>
    >
  >
operator- (const field_nonlinear_expr<Expr>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, y));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_function<Function>
     ,field_nonlinear_expr<Expr>
    >
  >
operator- (const field_expr_terminal_function<Function>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
     ,field_nonlinear_expr<Expr2>
    >
  >
operator- (const field_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type> arg1_t;
  typedef field_nonlinear_expr<Expr2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_nonlinear_expr<Expr1>
     ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
    >
  >
operator- (const field_nonlinear_expr<Expr1>& x, const field_expr<Expr2>& y)
{
  typedef field_nonlinear_expr<Expr1> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, arg2_t(y)));
}
template<class Function1, class Function2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_expr_terminal_function<Function1>
     ,field_expr_terminal_function<Function2>
    >
  >
operator- (const field_expr_terminal_function<Function1>& x, const field_expr_terminal_function<Function2>& y)
{
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_function<Function2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::minus
     ,field_nonlinear_expr<Expr1>
     ,field_nonlinear_expr<Expr2>
    >
  >
operator- (const field_nonlinear_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y)
{
  typedef field_nonlinear_expr<Expr1> arg1_t;
  typedef field_nonlinear_expr<Expr2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::minus, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::minus(), x, y));
}
namespace detail_nonlinear_expr {
  template <class T1, class T2> 
  struct multiplies_result {
    typedef undeterminated_basic<typename promote<typename scalar_traits<T1>::type,typename scalar_traits<T2>::type>::type> type;
  };
  template <class T> 
  struct multiplies_result<T,T> {
    typedef T type;
  };
  template <class T> 
  struct multiplies_result<point_basic<T>,point_basic<T> > {
    typedef undeterminated_basic<T> type;
  };
  template <class T> 
  struct multiplies_result<point_basic<T>,T> {
    typedef point_basic<T> type;
  };
  template <class T> 
  struct multiplies_result<T,point_basic<T> > {
    typedef point_basic<T> type;
  };
  template <class T> 
  struct multiplies_result<tensor_basic<T>,T> {
    typedef tensor_basic<T> type;
  };
  template <class T> 
  struct multiplies_result<T,tensor_basic<T> > {
    typedef tensor_basic<T> type;
  };
  template <class T> 
  struct multiplies_result<tensor_basic<T>,point_basic<T> > {
    typedef point_basic<T> type;
  };
  template <class T> 
  struct multiplies_result<point_basic<T>,tensor_basic<T> > {
    typedef undeterminated_basic<T> type;
  };
  struct multiplies {
    template <class T1, class T2>
    typename multiplies_result<T1,T2>::type
    operator() (const T1& a, const T2& b) const { return a*b; }
  };
} // namepace detail_nonlinear_expr
template<>
struct generic_binary_traits<detail_nonlinear_expr::multiplies> {
  template<class Result>
  struct with {
    typedef Result  result_type;
    typedef typename scalar_traits<Result>::type       scalar_type;
    typedef undeterminated_basic<scalar_type>  first_argument_type;
    typedef undeterminated_basic<scalar_type> second_argument_type;
    typedef detail_nonlinear_expr::multiplies function_type;
  };
  template <class Arg1, class Arg2>
  struct result_hint {
    typedef typename detail_nonlinear_expr::multiplies_result<Arg1,Arg2>::type type;
  };
  static space_constant::valued_type
  valued_tag (space_constant::valued_type tag1, space_constant::valued_type tag2) { 
    return space_constant::multiplies_result_tag(tag1,tag2);
  }
};
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::multiplies<typename field_nonlinear_expr<Expr>::scalar_type> >
   ,field_nonlinear_expr<Expr>
  >
>
operator* (const typename field_nonlinear_expr<Expr>::scalar_type& x, const field_nonlinear_expr<Expr>& y)
{
  typedef typename field_nonlinear_expr<Expr>::scalar_type                        scalar_t;
  typedef std::binder1st<std::multiplies<scalar_t> > fun_t;
  typedef field_nonlinear_expr<Expr>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::multiplies<scalar_t>(), x), y));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::multiplies<typename field_expr_terminal_function<Function>::scalar_type> >
   ,field_expr_terminal_function<Function>
  >
>
operator* (const typename field_expr_terminal_function<Function>::scalar_type& x, const field_expr_terminal_function<Function>& y)
{
  typedef typename field_expr_terminal_function<Function>::scalar_type                        scalar_t;
  typedef std::binder1st<std::multiplies<scalar_t> > fun_t;
  typedef field_expr_terminal_function<Function>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::multiplies<scalar_t>(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<std::multiplies<typename field_nonlinear_expr<Expr>::scalar_type> >
   ,field_nonlinear_expr<Expr>
  >
>
operator* (const field_nonlinear_expr<Expr>& x, const typename field_nonlinear_expr<Expr>::scalar_type& y)
{
  typedef typename field_nonlinear_expr<Expr>::scalar_type                        scalar_t;
  typedef std::binder2nd<std::multiplies<scalar_t> > fun_t;
  typedef field_nonlinear_expr<Expr>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::multiplies<scalar_t>(), y), x));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<std::multiplies<typename field_expr_terminal_function<Function>::scalar_type> >
   ,field_expr_terminal_function<Function>
  >
>
operator* (const field_expr_terminal_function<Function>& x, const typename field_expr_terminal_function<Function>::scalar_type& y)
{
  typedef typename field_expr_terminal_function<Function>::scalar_type                        scalar_t;
  typedef std::binder2nd<std::multiplies<scalar_t> > fun_t;
  typedef field_expr_terminal_function<Function>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::multiplies<scalar_t>(), y), x));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_basic<T,M>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_basic<T,M>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_basic<T,M>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_basic<T,M>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_basic<T,M>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_indirect<T,M>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_indirect<T,M>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_indirect<T,M>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_indirect<T,M>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_indirect<T,M>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_indirect_const<T,M>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_indirect_const<T,M>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_indirect_const<T,M>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_indirect_const<T,M>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_indirect_const<T,M>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_component<T,M>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_component<T,M>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_component<T,M>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_component<T,M>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_component<T,M>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_component_const<T,M>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_component_const<T,M>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_component_const<T,M>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_component_const<T,M>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_component_const<T,M>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator* (const field_basic<T,M>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_expr<Expr>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator* (const field_basic<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_expr_terminal_function<Function>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_nonlinear_expr<Expr>& x, const field_basic<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator* (const field_basic<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator* (const field_indirect<T,M>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_expr<Expr>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator* (const field_indirect<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_expr_terminal_function<Function>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_nonlinear_expr<Expr>& x, const field_indirect<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator* (const field_indirect<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator* (const field_indirect_const<T,M>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_expr<Expr>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator* (const field_indirect_const<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_expr_terminal_function<Function>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_nonlinear_expr<Expr>& x, const field_indirect_const<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator* (const field_indirect_const<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator* (const field_component<T,M>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_expr<Expr>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator* (const field_component<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_expr_terminal_function<Function>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_nonlinear_expr<Expr>& x, const field_component<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator* (const field_component<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator* (const field_component_const<T,M>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_expr<Expr>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator* (const field_component_const<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_expr_terminal_function<Function>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator* (const field_nonlinear_expr<Expr>& x, const field_component_const<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator* (const field_component_const<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
     ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
    >
  >
operator* (const field_expr<Expr1>& x, const field_expr<Expr2>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_function<Function>
    >
  >
operator* (const field_expr<Expr>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator* (const field_expr_terminal_function<Function>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_function<Function>
    >
  >
operator* (const field_nonlinear_expr<Expr>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, y));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_function<Function>
     ,field_nonlinear_expr<Expr>
    >
  >
operator* (const field_expr_terminal_function<Function>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
     ,field_nonlinear_expr<Expr2>
    >
  >
operator* (const field_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type> arg1_t;
  typedef field_nonlinear_expr<Expr2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_nonlinear_expr<Expr1>
     ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
    >
  >
operator* (const field_nonlinear_expr<Expr1>& x, const field_expr<Expr2>& y)
{
  typedef field_nonlinear_expr<Expr1> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, arg2_t(y)));
}
template<class Function1, class Function2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_expr_terminal_function<Function1>
     ,field_expr_terminal_function<Function2>
    >
  >
operator* (const field_expr_terminal_function<Function1>& x, const field_expr_terminal_function<Function2>& y)
{
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_function<Function2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::multiplies
     ,field_nonlinear_expr<Expr1>
     ,field_nonlinear_expr<Expr2>
    >
  >
operator* (const field_nonlinear_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y)
{
  typedef field_nonlinear_expr<Expr1> arg1_t;
  typedef field_nonlinear_expr<Expr2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::multiplies, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::multiplies(), x, y));
}
namespace detail_nonlinear_expr {
  template <class T1, class T2> 
  struct divides_result {
    typedef undeterminated_basic<typename promote<typename scalar_traits<T1>::type,typename scalar_traits<T2>::type>::type> type;
  };
  template <class T> 
  struct divides_result<T,T> {
    typedef T type;
  };
  template <class T> 
  struct divides_result<point_basic<T>,T> {
    typedef point_basic<T> type;
  };
  template <class T> 
  struct divides_result<tensor_basic<T>,T> {
    typedef tensor_basic<T> type;
  };
  struct divides {
    template <class T1, class T2>
    typename divides_result<T1,T2>::type
    operator() (const T1& a, const T2& b) const { return a/b; }
  };
} // namepace detail_nonlinear_expr
template<>
struct generic_binary_traits<detail_nonlinear_expr::divides> {
  template<class Result>
  struct with {
    typedef Result  result_type;
    typedef typename scalar_traits<Result>::type       scalar_type;
    typedef undeterminated_basic<scalar_type>  first_argument_type;
    typedef undeterminated_basic<scalar_type> second_argument_type;
    typedef detail_nonlinear_expr::divides function_type;
  };
  template <class Arg1, class Arg2>
  struct result_hint {
    typedef typename detail_nonlinear_expr::divides_result<Arg1,Arg2>::type type;
  };
  static space_constant::valued_type
  valued_tag (space_constant::valued_type tag1, space_constant::valued_type tag2) { 
    return space_constant::divides_result_tag(tag1,tag2);
  }
};
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::divides<typename field_basic<T,M>::scalar_type> >
   ,field_expr_terminal_field<T,M>
  >
>
operator/ (const typename field_basic<T,M>::scalar_type& x, const field_basic<T,M>& y)
{
  typedef typename field_basic<T,M>::scalar_type                        scalar_t;
  typedef std::binder1st<std::divides<scalar_t> > fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::divides<scalar_t>(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::divides<typename field_indirect<T,M>::scalar_type> >
   ,field_expr_terminal_field<T,M>
  >
>
operator/ (const typename field_indirect<T,M>::scalar_type& x, const field_indirect<T,M>& y)
{
  typedef typename field_indirect<T,M>::scalar_type                        scalar_t;
  typedef std::binder1st<std::divides<scalar_t> > fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::divides<scalar_t>(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::divides<typename field_indirect_const<T,M>::scalar_type> >
   ,field_expr_terminal_field<T,M>
  >
>
operator/ (const typename field_indirect_const<T,M>::scalar_type& x, const field_indirect_const<T,M>& y)
{
  typedef typename field_indirect_const<T,M>::scalar_type                        scalar_t;
  typedef std::binder1st<std::divides<scalar_t> > fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::divides<scalar_t>(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::divides<typename field_component<T,M>::scalar_type> >
   ,field_expr_terminal_field<T,M>
  >
>
operator/ (const typename field_component<T,M>::scalar_type& x, const field_component<T,M>& y)
{
  typedef typename field_component<T,M>::scalar_type                        scalar_t;
  typedef std::binder1st<std::divides<scalar_t> > fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::divides<scalar_t>(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::divides<typename field_component_const<T,M>::scalar_type> >
   ,field_expr_terminal_field<T,M>
  >
>
operator/ (const typename field_component_const<T,M>::scalar_type& x, const field_component_const<T,M>& y)
{
  typedef typename field_component_const<T,M>::scalar_type                        scalar_t;
  typedef std::binder1st<std::divides<scalar_t> > fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::divides<scalar_t>(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::divides<typename field_expr<Expr>::scalar_type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
operator/ (const typename field_expr<Expr>::scalar_type& x, const field_expr<Expr>& y)
{
  typedef typename field_expr<Expr>::scalar_type                        scalar_t;
  typedef std::binder1st<std::divides<scalar_t> > fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::divides<scalar_t>(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::divides<typename field_nonlinear_expr<Expr>::scalar_type> >
   ,field_nonlinear_expr<Expr>
  >
>
operator/ (const typename field_nonlinear_expr<Expr>::scalar_type& x, const field_nonlinear_expr<Expr>& y)
{
  typedef typename field_nonlinear_expr<Expr>::scalar_type                        scalar_t;
  typedef std::binder1st<std::divides<scalar_t> > fun_t;
  typedef field_nonlinear_expr<Expr>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::divides<scalar_t>(), x), y));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<std::divides<typename field_expr_terminal_function<Function>::scalar_type> >
   ,field_expr_terminal_function<Function>
  >
>
operator/ (const typename field_expr_terminal_function<Function>::scalar_type& x, const field_expr_terminal_function<Function>& y)
{
  typedef typename field_expr_terminal_function<Function>::scalar_type                        scalar_t;
  typedef std::binder1st<std::divides<scalar_t> > fun_t;
  typedef field_expr_terminal_function<Function>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::divides<scalar_t>(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<std::divides<typename field_nonlinear_expr<Expr>::scalar_type> >
   ,field_nonlinear_expr<Expr>
  >
>
operator/ (const field_nonlinear_expr<Expr>& x, const typename field_nonlinear_expr<Expr>::scalar_type& y)
{
  typedef typename field_nonlinear_expr<Expr>::scalar_type                        scalar_t;
  typedef std::binder2nd<std::divides<scalar_t> > fun_t;
  typedef field_nonlinear_expr<Expr>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::divides<scalar_t>(), y), x));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<std::divides<typename field_expr_terminal_function<Function>::scalar_type> >
   ,field_expr_terminal_function<Function>
  >
>
operator/ (const field_expr_terminal_function<Function>& x, const typename field_expr_terminal_function<Function>::scalar_type& y)
{
  typedef typename field_expr_terminal_function<Function>::scalar_type                        scalar_t;
  typedef std::binder2nd<std::divides<scalar_t> > fun_t;
  typedef field_expr_terminal_function<Function>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t, arg_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(std::divides<scalar_t>(), y), x));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_basic<T,M>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_basic<T,M>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_basic<T,M>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_basic<T,M>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_basic<T,M>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_indirect<T,M>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_indirect<T,M>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_indirect<T,M>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_indirect<T,M>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_indirect<T,M>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_indirect_const<T,M>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_indirect_const<T,M>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_indirect_const<T,M>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_indirect_const<T,M>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_indirect_const<T,M>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_component<T,M>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_component<T,M>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_component<T,M>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_component<T,M>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_component<T,M>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_component_const<T,M>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_component_const<T,M>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_component_const<T,M>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_component_const<T,M>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_component_const<T,M>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator/ (const field_basic<T,M>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_expr<Expr>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator/ (const field_basic<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_expr_terminal_function<Function>& x, const field_basic<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_nonlinear_expr<Expr>& x, const field_basic<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator/ (const field_basic<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator/ (const field_indirect<T,M>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_expr<Expr>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator/ (const field_indirect<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_expr_terminal_function<Function>& x, const field_indirect<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_nonlinear_expr<Expr>& x, const field_indirect<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator/ (const field_indirect<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator/ (const field_indirect_const<T,M>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_expr<Expr>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator/ (const field_indirect_const<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_expr_terminal_function<Function>& x, const field_indirect_const<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_nonlinear_expr<Expr>& x, const field_indirect_const<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator/ (const field_indirect_const<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator/ (const field_component<T,M>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_expr<Expr>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator/ (const field_component<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_expr_terminal_function<Function>& x, const field_component<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_nonlinear_expr<Expr>& x, const field_component<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator/ (const field_component<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator/ (const field_component_const<T,M>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_expr<Expr>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_expr_terminal_function<Function>
    >
  >
operator/ (const field_component_const<T,M>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_expr_terminal_function<Function>& x, const field_component_const<T,M>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_field<T,M>
    >
  >
operator/ (const field_nonlinear_expr<Expr>& x, const field_component_const<T,M>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<T,M>
     ,field_nonlinear_expr<Expr>
    >
  >
operator/ (const field_component_const<T,M>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
     ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
    >
  >
operator/ (const field_expr<Expr1>& x, const field_expr<Expr2>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), arg2_t(y)));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
     ,field_expr_terminal_function<Function>
    >
  >
operator/ (const field_expr<Expr>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_function<Function>
     ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
    >
  >
operator/ (const field_expr_terminal_function<Function>& x, const field_expr<Expr>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_nonlinear_expr<Expr>
     ,field_expr_terminal_function<Function>
    >
  >
operator/ (const field_nonlinear_expr<Expr>& x, const field_expr_terminal_function<Function>& y)
{
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_function<Function> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, y));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_function<Function>
     ,field_nonlinear_expr<Expr>
    >
  >
operator/ (const field_expr_terminal_function<Function>& x, const field_nonlinear_expr<Expr>& y)
{
  typedef field_expr_terminal_function<Function> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
     ,field_nonlinear_expr<Expr2>
    >
  >
operator/ (const field_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y)
{
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type> arg1_t;
  typedef field_nonlinear_expr<Expr2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_nonlinear_expr<Expr1>
     ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
    >
  >
operator/ (const field_nonlinear_expr<Expr1>& x, const field_expr<Expr2>& y)
{
  typedef field_nonlinear_expr<Expr1> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, arg2_t(y)));
}
template<class Function1, class Function2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_expr_terminal_function<Function1>
     ,field_expr_terminal_function<Function2>
    >
  >
operator/ (const field_expr_terminal_function<Function1>& x, const field_expr_terminal_function<Function2>& y)
{
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_function<Function2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
      detail_nonlinear_expr::divides
     ,field_nonlinear_expr<Expr1>
     ,field_nonlinear_expr<Expr2>
    >
  >
operator/ (const field_nonlinear_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y)
{
  typedef field_nonlinear_expr<Expr1> arg1_t;
  typedef field_nonlinear_expr<Expr2> arg2_t;
  typedef field_nonlinear_expr_bf<detail_nonlinear_expr::divides, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(detail_nonlinear_expr::divides(), x, y));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct cos_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return cos(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cos_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
cos (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::cos_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cos_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
cos (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::cos_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cos_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
cos (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::cos_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cos_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
cos (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::cos_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cos_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
cos (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::cos_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cos_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
cos (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::cos_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cos_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
cos (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::cos_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct sin_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return sin(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sin_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sin (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::sin_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sin_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sin (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::sin_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sin_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sin (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::sin_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sin_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sin (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::sin_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sin_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sin (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::sin_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sin_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
sin (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::sin_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sin_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
sin (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::sin_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct tan_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return tan(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tan_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
tan (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::tan_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tan_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
tan (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::tan_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tan_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
tan (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::tan_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tan_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
tan (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::tan_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tan_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
tan (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::tan_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tan_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
tan (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::tan_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tan_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
tan (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::tan_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct acos_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return acos(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::acos_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
acos (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::acos_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::acos_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
acos (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::acos_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::acos_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
acos (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::acos_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::acos_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
acos (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::acos_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::acos_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
acos (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::acos_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::acos_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
acos (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::acos_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::acos_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
acos (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::acos_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct asin_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return asin(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::asin_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
asin (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::asin_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::asin_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
asin (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::asin_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::asin_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
asin (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::asin_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::asin_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
asin (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::asin_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::asin_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
asin (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::asin_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::asin_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
asin (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::asin_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::asin_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
asin (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::asin_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct atan_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return atan(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::atan_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
atan (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::atan_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::atan_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
atan (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::atan_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::atan_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
atan (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::atan_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::atan_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
atan (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::atan_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::atan_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
atan (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::atan_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::atan_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::atan_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::atan_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
atan (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::atan_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct cosh_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return cosh(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cosh_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
cosh (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::cosh_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cosh_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
cosh (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::cosh_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cosh_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
cosh (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::cosh_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cosh_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
cosh (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::cosh_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cosh_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
cosh (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::cosh_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cosh_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
cosh (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::cosh_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::cosh_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
cosh (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::cosh_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct sinh_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return sinh(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sinh_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sinh (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::sinh_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sinh_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sinh (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::sinh_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sinh_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sinh (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::sinh_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sinh_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sinh (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::sinh_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sinh_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sinh (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::sinh_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sinh_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
sinh (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::sinh_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sinh_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
sinh (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::sinh_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct tanh_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return tanh(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tanh_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
tanh (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::tanh_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tanh_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
tanh (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::tanh_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tanh_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
tanh (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::tanh_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tanh_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
tanh (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::tanh_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tanh_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
tanh (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::tanh_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tanh_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
tanh (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::tanh_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::tanh_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
tanh (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::tanh_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct exp_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return exp(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::exp_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
exp (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::exp_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::exp_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
exp (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::exp_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::exp_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
exp (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::exp_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::exp_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
exp (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::exp_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::exp_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
exp (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::exp_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::exp_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
exp (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::exp_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::exp_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
exp (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::exp_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct log_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return log(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
log (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::log_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
log (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::log_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
log (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::log_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
log (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::log_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
log (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::log_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
log (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::log_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
log (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::log_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct log10_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return log10(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log10_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
log10 (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::log10_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log10_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
log10 (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::log10_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log10_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
log10 (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::log10_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log10_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
log10 (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::log10_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log10_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
log10 (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::log10_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log10_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
log10 (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::log10_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::log10_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
log10 (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::log10_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct sqrt_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return sqrt(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqrt_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sqrt (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::sqrt_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqrt_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sqrt (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::sqrt_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqrt_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sqrt (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::sqrt_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqrt_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sqrt (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::sqrt_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqrt_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sqrt (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::sqrt_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqrt_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
sqrt (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::sqrt_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqrt_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
sqrt (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::sqrt_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct abs_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return abs(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::abs_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
abs (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::abs_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::abs_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
abs (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::abs_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::abs_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
abs (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::abs_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::abs_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
abs (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::abs_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::abs_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
abs (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::abs_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::abs_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
abs (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::abs_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::abs_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
abs (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::abs_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct fabs_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return fabs(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::fabs_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
fabs (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::fabs_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::fabs_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
fabs (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::fabs_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::fabs_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
fabs (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::fabs_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::fabs_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
fabs (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::fabs_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::fabs_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
fabs (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::fabs_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::fabs_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fabs (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::fabs_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::fabs_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
fabs (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::fabs_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct floor_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return floor(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::floor_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
floor (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::floor_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::floor_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
floor (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::floor_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::floor_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
floor (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::floor_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::floor_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
floor (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::floor_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::floor_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
floor (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::floor_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::floor_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
floor (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::floor_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::floor_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
floor (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::floor_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct ceil_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return ceil(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::ceil_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
ceil (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::ceil_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::ceil_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
ceil (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::ceil_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::ceil_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
ceil (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::ceil_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::ceil_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
ceil (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::ceil_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::ceil_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
ceil (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::ceil_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::ceil_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
ceil (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::ceil_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::ceil_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
ceil (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::ceil_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct sqr_ : std::unary_function<T,T> {
    T operator() (const T& x) const { return sqr(x); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqr_<typename field_basic<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sqr (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::sqr_<typename field_basic<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqr_<typename field_indirect<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sqr (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::sqr_<typename field_indirect<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqr_<typename field_indirect_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sqr (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::sqr_<typename field_indirect_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqr_<typename field_component<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sqr (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::sqr_<typename field_component<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqr_<typename field_component_const<T,M>::scalar_type>
   ,field_expr_terminal_field<T,M>
  >
>
sqr (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::sqr_<typename field_component_const<T,M>::scalar_type> fun_t;
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqr_<typename field_expr<Expr>::scalar_type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
sqr (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::sqr_<typename field_expr<Expr>::scalar_type> fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::sqr_<typename field_nonlinear_expr<Expr>::scalar_type>
   ,field_nonlinear_expr<Expr>
  >
>
sqr (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::sqr_<typename field_nonlinear_expr<Expr>::scalar_type> fun_t;
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
struct norm_ {
  template<class T>
  typename float_traits<T>::type operator() (const T& x) const { return fabs(x); }
  template<class T>
  typename float_traits<T>::type operator() (const point_basic<T>& x) const { return norm(x); }
  template<class T>
  typename float_traits<T>::type operator() (const tensor_basic<T>& x) const { return norm(x); }
};
} // namespace detail_nonlinear_expr
template<>
struct generic_unary_traits<detail_nonlinear_expr::norm_> {
  template<class ResultType>
  struct with {
    typedef undeterminated_basic<ResultType>  argument_type;
    typedef ResultType                        result_type;
    typedef detail_nonlinear_expr::norm_           function_type;
  };
  template <class Arg>
  struct result_hint {
    typedef typename float_traits<Arg>::type  type;
  };
  static space_constant::valued_type
  valued_tag (space_constant::valued_type tag) {
    return space_constant::scalar;
  }
};
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm_
   ,field_expr_terminal_field<T,M>
  >
>
norm (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::norm_      fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm_
   ,field_expr_terminal_field<T,M>
  >
>
norm (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::norm_      fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm_
   ,field_expr_terminal_field<T,M>
  >
>
norm (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::norm_      fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm_
   ,field_expr_terminal_field<T,M>
  >
>
norm (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::norm_      fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm_
   ,field_expr_terminal_field<T,M>
  >
>
norm (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::norm_      fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm_
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
norm (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::norm_      fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm_
   ,field_expr_terminal_function<Function>
  >
>
norm (const field_expr_terminal_function<Function>& x) {
  typedef detail_nonlinear_expr::norm_      fun_t;
  typedef field_expr_terminal_function<Function>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm_
   ,field_nonlinear_expr<Expr>
  >
>
norm (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::norm_      fun_t;
  typedef field_nonlinear_expr<Expr>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
struct norm2_ {
  template<class T>
  typename float_traits<T>::type operator() (const T& x) const { return sqr(x); }
  template<class T>
  typename float_traits<T>::type operator() (const point_basic<T>& x) const { return norm2(x); }
  template<class T>
  typename float_traits<T>::type operator() (const tensor_basic<T>& x) const { return norm2(x); }
};
} // namespace detail_nonlinear_expr
template<>
struct generic_unary_traits<detail_nonlinear_expr::norm2_> {
  template<class ResultType>
  struct with {
    typedef undeterminated_basic<ResultType>  argument_type;
    typedef ResultType                        result_type;
    typedef detail_nonlinear_expr::norm2_           function_type;
  };
  template <class Arg>
  struct result_hint {
    typedef typename float_traits<Arg>::type  type;
  };
  static space_constant::valued_type
  valued_tag (space_constant::valued_type tag) {
    return space_constant::scalar;
  }
};
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm2_
   ,field_expr_terminal_field<T,M>
  >
>
norm2 (const field_basic<T,M>& x) {
  typedef detail_nonlinear_expr::norm2_      fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm2_
   ,field_expr_terminal_field<T,M>
  >
>
norm2 (const field_indirect<T,M>& x) {
  typedef detail_nonlinear_expr::norm2_      fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm2_
   ,field_expr_terminal_field<T,M>
  >
>
norm2 (const field_indirect_const<T,M>& x) {
  typedef detail_nonlinear_expr::norm2_      fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm2_
   ,field_expr_terminal_field<T,M>
  >
>
norm2 (const field_component<T,M>& x) {
  typedef detail_nonlinear_expr::norm2_      fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm2_
   ,field_expr_terminal_field<T,M>
  >
>
norm2 (const field_component_const<T,M>& x) {
  typedef detail_nonlinear_expr::norm2_      fun_t;
  typedef field_expr_terminal_field<T,M>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm2_
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
norm2 (const field_expr<Expr>& x) {
  typedef detail_nonlinear_expr::norm2_      fun_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg_t(x)));
}
template<class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm2_
   ,field_expr_terminal_function<Function>
  >
>
norm2 (const field_expr_terminal_function<Function>& x) {
  typedef detail_nonlinear_expr::norm2_      fun_t;
  typedef field_expr_terminal_function<Function>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    detail_nonlinear_expr::norm2_
   ,field_nonlinear_expr<Expr>
  >
>
norm2 (const field_nonlinear_expr<Expr>& x) {
  typedef detail_nonlinear_expr::norm2_      fun_t;
  typedef field_nonlinear_expr<Expr>                         arg_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>    expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct atan2_ : std::binary_function<T,T,T> {
    T operator() (const T& x, const T& y) const { return atan2(x,y); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<int,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const int& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<typename field_basic<T,M>::scalar_type,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const typename field_basic<T,M>::scalar_type& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<int,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const int& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<typename field_indirect<T,M>::scalar_type,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const typename field_indirect<T,M>::scalar_type& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<int,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const int& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<typename field_indirect_const<T,M>::scalar_type,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const typename field_indirect_const<T,M>::scalar_type& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<int,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const int& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<typename field_component<T,M>::scalar_type,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const typename field_component<T,M>::scalar_type& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<int,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const int& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<typename field_component_const<T,M>::scalar_type,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const typename field_component_const<T,M>::scalar_type& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<int,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const int& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const typename field_expr_terminal_function<Function1>::scalar_type& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<int,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan2 (const int& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<typename field_expr<Expr>::scalar_type,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan2 (const typename field_expr<Expr>::scalar_type& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<int,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
atan2 (const int& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::atan2_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
atan2 (const typename field_nonlinear_expr<Expr>::scalar_type& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<int,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_basic<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<typename field_basic<T,M>::scalar_type,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_basic<T,M>& x, const typename field_basic<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<int,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<typename field_indirect<T,M>::scalar_type,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect<T,M>& x, const typename field_indirect<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<int,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<typename field_indirect_const<T,M>::scalar_type,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect_const<T,M>& x, const typename field_indirect_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<int,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<typename field_component<T,M>::scalar_type,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component<T,M>& x, const typename field_component<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<int,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<typename field_component_const<T,M>::scalar_type,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component_const<T,M>& x, const typename field_component_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<int,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const field_expr_terminal_function<Function1>& x, const int& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const field_expr_terminal_function<Function1>& x, const typename field_expr_terminal_function<Function1>::scalar_type& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<int,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan2 (const field_expr<Expr>& x, const int& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<typename field_expr<Expr>::scalar_type,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan2 (const field_expr<Expr>& x, const typename field_expr<Expr>::scalar_type& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<int,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
atan2 (const field_nonlinear_expr<Expr>& x, const int& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::atan2_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
atan2 (const field_nonlinear_expr<Expr>& x, const typename field_nonlinear_expr<Expr>::scalar_type& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_basic<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_basic<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_basic<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_basic<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_basic<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_basic<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_basic<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_basic<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_indirect_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_component_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_basic<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan2 (const field_basic<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_basic<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const field_basic<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_expr_terminal_function<Function1>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_basic<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
atan2 (const field_basic<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_nonlinear_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan2 (const field_indirect<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const field_indirect<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_expr_terminal_function<Function1>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
atan2 (const field_indirect<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_nonlinear_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan2 (const field_indirect_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const field_indirect_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_expr_terminal_function<Function1>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
atan2 (const field_indirect_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_nonlinear_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan2 (const field_component<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const field_component<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_expr_terminal_function<Function1>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
atan2 (const field_component<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_nonlinear_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan2 (const field_component_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const field_component_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_expr_terminal_function<Function1>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
atan2 (const field_component_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
atan2 (const field_nonlinear_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
atan2 (const field_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_nonlinear_expr<Expr2>
  >
>
atan2 (const field_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>                                     arg1_t;
  typedef field_nonlinear_expr<Expr2>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type>
   ,field_nonlinear_expr<Expr1>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
atan2 (const field_nonlinear_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type>
   ,field_nonlinear_expr<Expr1>
   ,field_nonlinear_expr<Expr2>
  >
>
atan2 (const field_nonlinear_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1>                                     arg1_t;
  typedef field_nonlinear_expr<Expr2>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const field_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
atan2 (const field_expr_terminal_function<Function1>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_function<Function1>
  >
>
atan2 (const field_nonlinear_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_nonlinear_expr<Expr>
  >
>
atan2 (const field_expr_terminal_function<Function1>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Function1, class Function2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::atan2_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr_terminal_function<Function2>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_function<Function2>
  >
>
atan2 (const field_expr_terminal_function<Function1>& x, const field_expr_terminal_function<Function2>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_function<Function2>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr_terminal_function<Function2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::atan2_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct pow_ : std::binary_function<T,T,T> {
    T operator() (const T& x, const T& y) const { return pow(x,y); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<int,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const int& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<typename field_basic<T,M>::scalar_type,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const typename field_basic<T,M>::scalar_type& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<int,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const int& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<typename field_indirect<T,M>::scalar_type,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const typename field_indirect<T,M>::scalar_type& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<int,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const int& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<typename field_indirect_const<T,M>::scalar_type,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const typename field_indirect_const<T,M>::scalar_type& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<int,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const int& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<typename field_component<T,M>::scalar_type,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const typename field_component<T,M>::scalar_type& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<int,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const int& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<typename field_component_const<T,M>::scalar_type,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const typename field_component_const<T,M>::scalar_type& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<int,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
pow (const int& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
pow (const typename field_expr_terminal_function<Function1>::scalar_type& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<int,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
pow (const int& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<typename field_expr<Expr>::scalar_type,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
pow (const typename field_expr<Expr>::scalar_type& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<int,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
pow (const int& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::pow_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
pow (const typename field_nonlinear_expr<Expr>::scalar_type& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<int,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_basic<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<typename field_basic<T,M>::scalar_type,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_basic<T,M>& x, const typename field_basic<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<int,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<typename field_indirect<T,M>::scalar_type,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect<T,M>& x, const typename field_indirect<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<int,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<typename field_indirect_const<T,M>::scalar_type,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect_const<T,M>& x, const typename field_indirect_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<int,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<typename field_component<T,M>::scalar_type,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component<T,M>& x, const typename field_component<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<int,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<typename field_component_const<T,M>::scalar_type,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component_const<T,M>& x, const typename field_component_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<int,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
pow (const field_expr_terminal_function<Function1>& x, const int& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
pow (const field_expr_terminal_function<Function1>& x, const typename field_expr_terminal_function<Function1>::scalar_type& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<int,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
pow (const field_expr<Expr>& x, const int& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<typename field_expr<Expr>::scalar_type,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
pow (const field_expr<Expr>& x, const typename field_expr<Expr>::scalar_type& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<int,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
pow (const field_nonlinear_expr<Expr>& x, const int& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::pow_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
pow (const field_nonlinear_expr<Expr>& x, const typename field_nonlinear_expr<Expr>::scalar_type& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_basic<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_basic<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_basic<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_basic<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_basic<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_basic<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_basic<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_basic<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_indirect_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_component_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_basic<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
pow (const field_basic<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_basic<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
pow (const field_basic<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_expr_terminal_function<Function1>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_basic<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
pow (const field_basic<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_nonlinear_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
pow (const field_indirect<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
pow (const field_indirect<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_expr_terminal_function<Function1>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
pow (const field_indirect<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_nonlinear_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
pow (const field_indirect_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
pow (const field_indirect_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_expr_terminal_function<Function1>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
pow (const field_indirect_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_nonlinear_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
pow (const field_component<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
pow (const field_component<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_expr_terminal_function<Function1>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
pow (const field_component<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_nonlinear_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
pow (const field_component_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
pow (const field_component_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_expr_terminal_function<Function1>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
pow (const field_component_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
pow (const field_nonlinear_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
pow (const field_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_nonlinear_expr<Expr2>
  >
>
pow (const field_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>                                     arg1_t;
  typedef field_nonlinear_expr<Expr2>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type>
   ,field_nonlinear_expr<Expr1>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
pow (const field_nonlinear_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type>
   ,field_nonlinear_expr<Expr1>
   ,field_nonlinear_expr<Expr2>
  >
>
pow (const field_nonlinear_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1>                                     arg1_t;
  typedef field_nonlinear_expr<Expr2>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_function<Function1>
  >
>
pow (const field_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
pow (const field_expr_terminal_function<Function1>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_function<Function1>
  >
>
pow (const field_nonlinear_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_nonlinear_expr<Expr>
  >
>
pow (const field_expr_terminal_function<Function1>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Function1, class Function2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::pow_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr_terminal_function<Function2>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_function<Function2>
  >
>
pow (const field_expr_terminal_function<Function1>& x, const field_expr_terminal_function<Function2>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_function<Function2>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr_terminal_function<Function2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::pow_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct fmod_ : std::binary_function<T,T,T> {
    T operator() (const T& x, const T& y) const { return fmod(x,y); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<int,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const int& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<typename field_basic<T,M>::scalar_type,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const typename field_basic<T,M>::scalar_type& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<int,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const int& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<typename field_indirect<T,M>::scalar_type,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const typename field_indirect<T,M>::scalar_type& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<int,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const int& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<typename field_indirect_const<T,M>::scalar_type,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const typename field_indirect_const<T,M>::scalar_type& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<int,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const int& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<typename field_component<T,M>::scalar_type,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const typename field_component<T,M>::scalar_type& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<int,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const int& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<typename field_component_const<T,M>::scalar_type,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const typename field_component_const<T,M>::scalar_type& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<int,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const int& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const typename field_expr_terminal_function<Function1>::scalar_type& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<int,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fmod (const int& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<typename field_expr<Expr>::scalar_type,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fmod (const typename field_expr<Expr>::scalar_type& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<int,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
fmod (const int& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::fmod_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
fmod (const typename field_nonlinear_expr<Expr>::scalar_type& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<int,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_basic<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<typename field_basic<T,M>::scalar_type,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_basic<T,M>& x, const typename field_basic<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<int,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<typename field_indirect<T,M>::scalar_type,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect<T,M>& x, const typename field_indirect<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<int,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<typename field_indirect_const<T,M>::scalar_type,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect_const<T,M>& x, const typename field_indirect_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<int,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<typename field_component<T,M>::scalar_type,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component<T,M>& x, const typename field_component<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<int,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<typename field_component_const<T,M>::scalar_type,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component_const<T,M>& x, const typename field_component_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<int,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const field_expr_terminal_function<Function1>& x, const int& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const field_expr_terminal_function<Function1>& x, const typename field_expr_terminal_function<Function1>::scalar_type& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<int,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fmod (const field_expr<Expr>& x, const int& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<typename field_expr<Expr>::scalar_type,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fmod (const field_expr<Expr>& x, const typename field_expr<Expr>::scalar_type& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<int,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
fmod (const field_nonlinear_expr<Expr>& x, const int& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::fmod_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
fmod (const field_nonlinear_expr<Expr>& x, const typename field_nonlinear_expr<Expr>::scalar_type& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_basic<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_basic<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_basic<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_basic<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_basic<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_basic<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_basic<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_basic<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_indirect_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_component_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_basic<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fmod (const field_basic<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_basic<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const field_basic<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_expr_terminal_function<Function1>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_basic<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
fmod (const field_basic<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_nonlinear_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fmod (const field_indirect<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const field_indirect<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_expr_terminal_function<Function1>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
fmod (const field_indirect<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_nonlinear_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fmod (const field_indirect_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const field_indirect_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_expr_terminal_function<Function1>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
fmod (const field_indirect_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_nonlinear_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fmod (const field_component<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const field_component<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_expr_terminal_function<Function1>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
fmod (const field_component<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_nonlinear_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fmod (const field_component_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const field_component_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_expr_terminal_function<Function1>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
fmod (const field_component_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
fmod (const field_nonlinear_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
fmod (const field_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_nonlinear_expr<Expr2>
  >
>
fmod (const field_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>                                     arg1_t;
  typedef field_nonlinear_expr<Expr2>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type>
   ,field_nonlinear_expr<Expr1>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
fmod (const field_nonlinear_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type>
   ,field_nonlinear_expr<Expr1>
   ,field_nonlinear_expr<Expr2>
  >
>
fmod (const field_nonlinear_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1>                                     arg1_t;
  typedef field_nonlinear_expr<Expr2>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const field_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
fmod (const field_expr_terminal_function<Function1>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_function<Function1>
  >
>
fmod (const field_nonlinear_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_nonlinear_expr<Expr>
  >
>
fmod (const field_expr_terminal_function<Function1>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Function1, class Function2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::fmod_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr_terminal_function<Function2>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_function<Function2>
  >
>
fmod (const field_expr_terminal_function<Function1>& x, const field_expr_terminal_function<Function2>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_function<Function2>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr_terminal_function<Function2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::fmod_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct min_ : std::binary_function<T,T,T> {
    T operator() (const T& x, const T& y) const { return min(x,y); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<int,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const int& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<typename field_basic<T,M>::scalar_type,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const typename field_basic<T,M>::scalar_type& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<int,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const int& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<typename field_indirect<T,M>::scalar_type,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const typename field_indirect<T,M>::scalar_type& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<int,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const int& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<typename field_indirect_const<T,M>::scalar_type,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const typename field_indirect_const<T,M>::scalar_type& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<int,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const int& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<typename field_component<T,M>::scalar_type,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const typename field_component<T,M>::scalar_type& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<int,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const int& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<typename field_component_const<T,M>::scalar_type,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const typename field_component_const<T,M>::scalar_type& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<int,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
min (const int& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
min (const typename field_expr_terminal_function<Function1>::scalar_type& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<int,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
min (const int& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<typename field_expr<Expr>::scalar_type,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
min (const typename field_expr<Expr>::scalar_type& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<int,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
min (const int& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::min_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
min (const typename field_nonlinear_expr<Expr>::scalar_type& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<int,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_basic<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<typename field_basic<T,M>::scalar_type,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_basic<T,M>& x, const typename field_basic<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<int,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<typename field_indirect<T,M>::scalar_type,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect<T,M>& x, const typename field_indirect<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<int,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<typename field_indirect_const<T,M>::scalar_type,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect_const<T,M>& x, const typename field_indirect_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<int,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<typename field_component<T,M>::scalar_type,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component<T,M>& x, const typename field_component<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<int,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<typename field_component_const<T,M>::scalar_type,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component_const<T,M>& x, const typename field_component_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<int,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
min (const field_expr_terminal_function<Function1>& x, const int& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
min (const field_expr_terminal_function<Function1>& x, const typename field_expr_terminal_function<Function1>::scalar_type& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<int,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
min (const field_expr<Expr>& x, const int& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<typename field_expr<Expr>::scalar_type,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
min (const field_expr<Expr>& x, const typename field_expr<Expr>::scalar_type& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<int,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
min (const field_nonlinear_expr<Expr>& x, const int& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::min_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
min (const field_nonlinear_expr<Expr>& x, const typename field_nonlinear_expr<Expr>::scalar_type& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_basic<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_basic<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_basic<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_basic<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_basic<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_basic<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_basic<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_basic<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_indirect_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_component_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_basic<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
min (const field_basic<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_basic<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
min (const field_basic<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_expr_terminal_function<Function1>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_basic<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
min (const field_basic<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_nonlinear_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
min (const field_indirect<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
min (const field_indirect<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_expr_terminal_function<Function1>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
min (const field_indirect<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_nonlinear_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
min (const field_indirect_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
min (const field_indirect_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_expr_terminal_function<Function1>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
min (const field_indirect_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_nonlinear_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
min (const field_component<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
min (const field_component<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_expr_terminal_function<Function1>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
min (const field_component<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_nonlinear_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
min (const field_component_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
min (const field_component_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_expr_terminal_function<Function1>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
min (const field_component_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
min (const field_nonlinear_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
min (const field_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_nonlinear_expr<Expr2>
  >
>
min (const field_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>                                     arg1_t;
  typedef field_nonlinear_expr<Expr2>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type>
   ,field_nonlinear_expr<Expr1>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
min (const field_nonlinear_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type>
   ,field_nonlinear_expr<Expr1>
   ,field_nonlinear_expr<Expr2>
  >
>
min (const field_nonlinear_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1>                                     arg1_t;
  typedef field_nonlinear_expr<Expr2>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_function<Function1>
  >
>
min (const field_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
min (const field_expr_terminal_function<Function1>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_function<Function1>
  >
>
min (const field_nonlinear_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_nonlinear_expr<Expr>
  >
>
min (const field_expr_terminal_function<Function1>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Function1, class Function2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::min_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr_terminal_function<Function2>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_function<Function2>
  >
>
min (const field_expr_terminal_function<Function1>& x, const field_expr_terminal_function<Function2>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_function<Function2>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr_terminal_function<Function2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::min_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
namespace detail_nonlinear_expr {
  template<class T>
  struct max_ : std::binary_function<T,T,T> {
    T operator() (const T& x, const T& y) const { return max(x,y); }
  };
} // namespace detail_nonlinear_expr
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<int,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const int& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<typename field_basic<T,M>::scalar_type,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const typename field_basic<T,M>::scalar_type& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<int,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const int& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<typename field_indirect<T,M>::scalar_type,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const typename field_indirect<T,M>::scalar_type& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<int,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const int& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<typename field_indirect_const<T,M>::scalar_type,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const typename field_indirect_const<T,M>::scalar_type& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<int,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const int& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<typename field_component<T,M>::scalar_type,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const typename field_component<T,M>::scalar_type& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<int,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const int& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<typename field_component_const<T,M>::scalar_type,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const typename field_component_const<T,M>::scalar_type& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<int,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
max (const int& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
max (const typename field_expr_terminal_function<Function1>::scalar_type& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<int,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
max (const int& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<typename field_expr<Expr>::scalar_type,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
max (const typename field_expr<Expr>::scalar_type& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<int,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
max (const int& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<detail_nonlinear_expr::max_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
max (const typename field_nonlinear_expr<Expr>::scalar_type& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<int,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_basic<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<typename field_basic<T,M>::scalar_type,typename field_basic<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_basic<T,M>& x, const typename field_basic<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<int,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<typename field_indirect<T,M>::scalar_type,typename field_indirect<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect<T,M>& x, const typename field_indirect<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<int,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<typename field_indirect_const<T,M>::scalar_type,typename field_indirect_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect_const<T,M>& x, const typename field_indirect_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<int,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<typename field_component<T,M>::scalar_type,typename field_component<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component<T,M>& x, const typename field_component<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<int,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<typename field_component_const<T,M>::scalar_type,typename field_component_const<T,M>::scalar_type>::type> >
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component_const<T,M>& x, const typename field_component_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<int,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
max (const field_expr_terminal_function<Function1>& x, const int& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename field_expr_terminal_function<Function1>::scalar_type>::type> >
   ,field_expr_terminal_function<Function1>
  >
>
max (const field_expr_terminal_function<Function1>& x, const typename field_expr_terminal_function<Function1>::scalar_type& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<int,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
max (const field_expr<Expr>& x, const int& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<typename field_expr<Expr>::scalar_type,typename field_expr<Expr>::scalar_type>::type> >
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
max (const field_expr<Expr>& x, const typename field_expr<Expr>::scalar_type& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<int,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
max (const field_nonlinear_expr<Expr>& x, const int& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<detail_nonlinear_expr::max_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename field_nonlinear_expr<Expr>::scalar_type>::type> >
   ,field_nonlinear_expr<Expr>
  >
>
max (const field_nonlinear_expr<Expr>& x, const typename field_nonlinear_expr<Expr>::scalar_type& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_basic<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_basic<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_basic<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_basic<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_basic<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_basic<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_basic<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_basic<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_indirect_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_component_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_basic<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
max (const field_basic<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_basic<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
max (const field_basic<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_expr_terminal_function<Function1>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_basic<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
max (const field_basic<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_nonlinear_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_basic<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
max (const field_indirect<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
max (const field_indirect<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_expr_terminal_function<Function1>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
max (const field_indirect<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_nonlinear_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
max (const field_indirect_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
max (const field_indirect_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_expr_terminal_function<Function1>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
max (const field_indirect_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_nonlinear_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_indirect_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
max (const field_component<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
max (const field_component<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_expr_terminal_function<Function1>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
max (const field_component<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_component<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_nonlinear_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
max (const field_component_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
max (const field_component_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_expr_terminal_function<Function1>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_component_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
max (const field_component_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class T, class M, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
max (const field_nonlinear_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_field<T,M>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_component_const<T,M>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
max (const field_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_nonlinear_expr<Expr2>
  >
>
max (const field_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>                                     arg1_t;
  typedef field_nonlinear_expr<Expr2>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type>
   ,field_nonlinear_expr<Expr1>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
max (const field_nonlinear_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type>
   ,field_nonlinear_expr<Expr1>
   ,field_nonlinear_expr<Expr2>
  >
>
max (const field_nonlinear_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1>                                     arg1_t;
  typedef field_nonlinear_expr<Expr2>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr1>::scalar_type, typename field_nonlinear_expr<Expr2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_function<Function1>
  >
>
max (const field_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), arg1_t(x), y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
max (const field_expr_terminal_function<Function1>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, arg2_t(y)));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type>
   ,field_nonlinear_expr<Expr>
   ,field_expr_terminal_function<Function1>
  >
>
max (const field_nonlinear_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_nonlinear_expr<Expr>                                     arg1_t;
  typedef field_expr_terminal_function<Function1>                                     arg2_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type, typename field_expr_terminal_function<Function1>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Expr, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_nonlinear_expr<Expr>
  >
>
max (const field_expr_terminal_function<Function1>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_nonlinear_expr<Expr>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_nonlinear_expr<Expr>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class Function1, class Function2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    detail_nonlinear_expr::max_<typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr_terminal_function<Function2>::scalar_type>::type>
   ,field_expr_terminal_function<Function1>
   ,field_expr_terminal_function<Function2>
  >
>
max (const field_expr_terminal_function<Function1>& x, const field_expr_terminal_function<Function2>& y) {
  typedef field_expr_terminal_function<Function1>                                     arg1_t;
  typedef field_expr_terminal_function<Function2>                                     arg2_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type, typename field_expr_terminal_function<Function2>::scalar_type>::type scalar_t;
  typedef detail_nonlinear_expr::max_<scalar_t>           fun_t;
  typedef field_nonlinear_expr_bf<fun_t,arg1_t,arg2_t>         expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(), x, y));
}
template<class T, class M, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    Function
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_basic<T,M>& x) {
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<Function, arg_t> expr_t;
  return field_nonlinear_expr<expr_t> (expr_t(f, arg_t(x)));
}
template<class T, class M, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    Function
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect<T,M>& x) {
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<Function, arg_t> expr_t;
  return field_nonlinear_expr<expr_t> (expr_t(f, arg_t(x)));
}
template<class T, class M, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    Function
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x) {
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<Function, arg_t> expr_t;
  return field_nonlinear_expr<expr_t> (expr_t(f, arg_t(x)));
}
template<class T, class M, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    Function
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component<T,M>& x) {
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<Function, arg_t> expr_t;
  return field_nonlinear_expr<expr_t> (expr_t(f, arg_t(x)));
}
template<class T, class M, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    Function
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component_const<T,M>& x) {
  typedef field_expr_terminal_field<T,M>                          arg_t;
  typedef field_nonlinear_expr_uf<Function, arg_t> expr_t;
  return field_nonlinear_expr<expr_t> (expr_t(f, arg_t(x)));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    Function
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const field_expr<Expr>& x) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                          arg_t;
  typedef field_nonlinear_expr_uf<Function, arg_t> expr_t;
  return field_nonlinear_expr<expr_t> (expr_t(f, arg_t(x)));
}
template<class Expr, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    Function
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr>& x) {
  typedef field_nonlinear_expr<Expr>                          arg_t;
  typedef field_nonlinear_expr_uf<Function, arg_t> expr_t;
  return field_nonlinear_expr<expr_t> (expr_t(f, x));
}
template<class Function1, class Function>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    Function
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x) {
  typedef field_expr_terminal_function<Function1>                          arg_t;
  typedef field_nonlinear_expr_uf<Function, arg_t> expr_t;
  return field_nonlinear_expr<expr_t> (expr_t(f, x));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const int& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const typename field_basic<T,M>::scalar_type& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const int& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const typename field_indirect<T,M>::scalar_type& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const int& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const typename field_indirect_const<T,M>::scalar_type& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const int& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const typename field_component<T,M>::scalar_type& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const int& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const typename field_component_const<T,M>::scalar_type& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const int& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Function, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const typename field_expr_terminal_function<Function1>::scalar_type& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Function, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const int& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const typename field_expr<Expr>::scalar_type& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), arg_t(y)));
}
template<class Function, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const int& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Function, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder1st<Function>
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const typename field_nonlinear_expr<Expr>::scalar_type& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder1st<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), x), y));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_basic<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_basic<T,M>& x, const typename field_basic<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_basic<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect<T,M>& x, const typename field_indirect<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x, const typename field_indirect_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_indirect_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component<T,M>& x, const typename field_component<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component_const<T,M>& x, const int& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component_const<T,M>& x, const typename field_component_const<T,M>::scalar_type& y) {
  typedef field_expr_terminal_field<T,M>                                      arg_t;
  typedef typename promote<typename field_component_const<T,M>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x, const int& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Function, class Function1>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x, const typename field_expr_terminal_function<Function1>::scalar_type& y) {
  typedef field_expr_terminal_function<Function1>                                      arg_t;
  typedef typename promote<typename field_expr_terminal_function<Function1>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Function, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const field_expr<Expr>& x, const int& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const field_expr<Expr>& x, const typename field_expr<Expr>::scalar_type& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>                                      arg_t;
  typedef typename promote<typename field_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), arg_t(x)));
}
template<class Function, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr>& x, const int& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<int,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Function, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_uf<
    std::binder2nd<Function>
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr>& x, const typename field_nonlinear_expr<Expr>::scalar_type& y) {
  typedef field_nonlinear_expr<Expr>                                      arg_t;
  typedef typename promote<typename field_nonlinear_expr<Expr>::scalar_type,typename arg_t::scalar_type>::type scalar_t;
  typedef Function                                             funb_t;
  typedef std::binder2nd<funb_t>                        fun_t;
  typedef field_nonlinear_expr_uf<fun_t,arg_t>                 expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(fun_t(funb_t(), y), x));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_basic<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_basic<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_basic<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_basic<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_basic<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component_const<T,M>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component_const<T,M>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component_const<T,M>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component_const<T,M>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_component_const<T,M>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Function1, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const field_basic<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function1> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Function1, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const field_basic<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const field_basic<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr>& x, const field_basic<T,M>& y) {
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Function1, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const field_indirect<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function1> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Function1, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const field_indirect<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const field_indirect<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr>& x, const field_indirect<T,M>& y) {
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Function1, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function1> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Function1, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const field_indirect_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr>& x, const field_indirect_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Function1, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const field_component<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function1> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Function1, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const field_component<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const field_component<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr>& x, const field_component<T,M>& y) {
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Function1, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const field_component_const<T,M>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_function<Function1> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Function1, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const field_component_const<T,M>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<T,M>
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const field_component_const<T,M>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_field<T,M> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Expr, class T, class M>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_nonlinear_expr<Expr>
   ,field_expr_terminal_field<T,M>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr>& x, const field_component_const<T,M>& y) {
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_field<T,M> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
compose (const Function& f, const field_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), arg2_t(y)));
}
template<class Function, class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_nonlinear_expr<Expr1>
   ,field_nonlinear_expr<Expr2>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1> arg1_t;
  typedef field_nonlinear_expr<Expr2> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, y));
}
template<class Function, class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type>
   ,field_nonlinear_expr<Expr2>
  >
>
compose (const Function& f, const field_expr<Expr1>& x, const field_nonlinear_expr<Expr2>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr1>::scalar_type, typename field_expr<Expr1>::memory_type> arg1_t;
  typedef field_nonlinear_expr<Expr2> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Expr1, class Expr2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_nonlinear_expr<Expr1>
   ,field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr1>& x, const field_expr<Expr2>& y) {
  typedef field_nonlinear_expr<Expr1> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr2>::scalar_type, typename field_expr<Expr2>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Function1, class Function2>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_function<Function1>
   ,field_expr_terminal_function<Function2>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x, const field_expr_terminal_function<Function2>& y) {
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_function<Function2> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, y));
}
template<class Function, class Function1, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_function<Function1>
   ,field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x, const field_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, arg2_t(y)));
}
template<class Function, class Function1, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const field_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_expr_terminal_field<typename field_expr<Expr>::scalar_type, typename field_expr<Expr>::memory_type> arg1_t;
  typedef field_expr_terminal_function<Function1> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, arg1_t(x), y));
}
template<class Function, class Function1, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_expr_terminal_function<Function1>
   ,field_nonlinear_expr<Expr>
  >
>
compose (const Function& f, const field_expr_terminal_function<Function1>& x, const field_nonlinear_expr<Expr>& y) {
  typedef field_expr_terminal_function<Function1> arg1_t;
  typedef field_nonlinear_expr<Expr> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, y));
}
template<class Function, class Function1, class Expr>
inline
field_nonlinear_expr<
  field_nonlinear_expr_bf<
    Function,
    field_nonlinear_expr<Expr>
   ,field_expr_terminal_function<Function1>
  >
>
compose (const Function& f, const field_nonlinear_expr<Expr>& x, const field_expr_terminal_function<Function1>& y) {
  typedef field_nonlinear_expr<Expr> arg1_t;
  typedef field_expr_terminal_function<Function1> arg2_t;
  typedef field_nonlinear_expr_bf<Function, arg1_t, arg2_t>   expr_t;
  return field_nonlinear_expr<expr_t>(expr_t(f, x, y));
}
} // namespace rheolef
#endif // _RHEOLEF_FIELD_NONLINEAR_EXPR_OPS_H
